#include "StdAfx.h"

#include "GameTalkAPIGlobal.h"
#include "MessengerActor.h"
#include "_t_UTF8.h"
#include "UtilFunction.h"
#include "GameTalkNotifyCommand.h" 
#include "ConvertUTF.h"
#include "GBStream.h"
#include "WASActor.h"
#include "HangameLoginResultParser.h"
#include "NotificationProxy.h"
//#include "RoomManager.h"
//#include "MMCRoomActor.h"
#include "GTCommonAPI.h"
//#include "GTStopWatch.h"

//stopwatch_t g_nInternalPresetStopWatch1;
//stopwatch_t g_nInternalPresetStopWatch2;
//stopwatch_t g_nInternalPresetStopWatch3;
//stopwatch_t g_nInternalPresetStopWatch4;

CMessengerActor::CMessengerActor(void) 
	:	m_pNpMsgr(NULL)
//		,m_log()
		,m_eLogoutType(lortByUserCommand)
		,m_bIsFirstLogin(false)
		,m_bLoginWorking(false)
        ,m_bReloginWorking(false)   // when occured rejoin in internal engine, we need to reconize that situation..
		,m_bMobileLoginFlag(false)
		,m_bReloginOKFlag(false)
		,m_bIsEverLoginOKFlag(false)
        ,m_bLoadBuddyList(false)
		,m_nDefaultGroupID(1)
        ,m_nBuddyGroupSerial(0)
		,m_pAuthTicketProxy(NULL)
		,m_pWASActor(NULL)
		,m_pProfileImageActor(NULL)
		,m_eOSType(osWindows)
		,m_nCategoryCacheSerial(0)
		,m_VirtualBuddyGroup(this)
		,m_VirtualBuddyUser(NULL)
{
	//CGTLifeLog log(__FUNCTION__);

	srand( (unsigned)time( NULL ) );

	m_pMainThreadID = GetCurrentThreadId();
	
	//  ü ʱȭ
	m_sMyUserData.Clear();
	m_sSpecInfo.Clear();
	m_sLoginErrorData.Clear();
	
	m_mutexBuddy.SetRecursive();
	
	//   ߿.
	//   Ģ ݵ Ѿ.
	// 1. CWASActor CProfileImageActor  Ǿ.
	// 2. CWASActor CRoomManager  Ǿ.

	////////////////////////////////////////
	// 1. WAS Actor 
	m_pWASActor = new CWASActor(this);
	GT_ASSERT(m_pWASActor);
	m_pWASActor->RegisterObserverEx(this);
	
	////////////////////////////////////////
	// 2. ProfileImage Actor 
	m_pProfileImageActor = new CProfileImageActor(this);
	GT_ASSERT(m_pProfileImageActor);

	////////////////////////////////////////
	// 3. NpMsgr ̽ ⼭ .
	// NpMsgr α  ȣϴ ̽ ƴϹǷ
	// ⼭  Ѵ.
	// ȵǸ GT_ASSERT!
	m_pNpMsgr = CreateNpMsgr(this);	// from NpMsgr.dll (lib)
	GT_ASSERT(m_pNpMsgr);

	m_pNpMsgr->GetNpMsgrBuddy()->AdviseEvents(this);
	m_pNpMsgr->GetNpMsgrIPT()->AdviseEvents(this);

	// JS   DLL ѱ!
	m_pNpMsgr->SetLoginServerAddress(GT_GLOBAL->GetEnvironment().sLoginServerAddress.strAddress.c_str(), 
									 GT_GLOBAL->GetEnvironment().sLoginServerAddress.nPort);
}


CMessengerActor::~CMessengerActor(void)
{
	//CGTLifeLog log(__FUNCTION__);

	if(m_pNpMsgr)
	{
		m_pNpMsgr->GetNpMsgrBuddy()->UnadviseEvents(this);
		m_pNpMsgr->GetNpMsgrIPT()->UnadviseEvents(this);
	}

	//   ߿.
	//   Ģ ݵ Ѿ.
	// 0. CMessengerActor       Ŀ ؾ.
	// 1. CProfileImageActor CRoomManager  Ǿ.
	// 2. CRoomAccusationActor CRoomManager  Ǿ.
	// 3. CWASActor  ߿ Ǿ .
	// 
	// 
	// CWASActor CVoiceRoomActor   ϹǷ   ŵǾ
	// ´  ָ  ,  켱 ϸ (CWASAddCallHistory)
	// CWASActor ߿ ŵǴ   .
	//  ޽¡ ó(WASó, NotificationProxy) ̱۽ Ǳ  
	// ߸ ޸𸮸 ǵ   .
	
	m_pProfileImageActor->ReleaseObject();
	
	//  ߿ սô.
	m_pWASActor->UnRegisterObserverEx(this);
	m_pWASActor->ReleaseObject();

	if(m_pNpMsgr)
	{
		m_pNpMsgr->Delete();
		m_pNpMsgr = NULL;
	}

	_ClearBuddyList();
	_ClearBuddyPersistMap();
	_ClearBuddyGroupList();

//	log.Trace("%s : DELETE ACTOR RESULT => OBSERVER = %d, REF = %d", __FUNCTION__, size(), RetainCount());
//	log.End();
}


//----------------------------------------------
// CAUTION!
// NOT THREAD SAFE
// SO MUST BE CALLED IN MAIN THREAD!
//----------------------------------------------
void CMessengerActor::_ClearBuddyList(void)
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);

	buddyvector_t::iterator it = m_vecBuddy.begin();
	for (; it != m_vecBuddy.end(); ++it)
	{
		(*it)->ReleaseUser();
	}
	m_vecBuddy.clear();
}

void CMessengerActor::_ClearBuddyPersistMap(void)
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);

	buddymap_t::iterator it = m_mapBuddyPersist.begin();
	for (; it != m_mapBuddyPersist.end(); ++it)
	{
		it->second->ReleaseUser();
	}
	m_mapBuddyPersist.clear();
}


//----------------------------------------------
// CAUTION!
// NOT THREAD SAFE
// SO MUST BE CALLED IN MAIN THREAD!
//----------------------------------------------
void CMessengerActor::_ClearBuddyGroupList(void)
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);

	//GT_FLOG(L"[LOGIN] _ClearBuddyGroupList %d", m_vecBuddyGroup.size());
   
	buddygroupvector_t::iterator it = m_vecBuddyGroup.begin();
	for (; it != m_vecBuddyGroup.end(); ++it)
		(*it)->ReleseGroup();
	m_vecBuddyGroup.clear();
}

LPCSTR CMessengerActor::GetNewMessengerTicket(void)
{
	if(m_pAuthTicketProxy)
	{
		char szTicket[1024] = {0, };
		
		if(m_pAuthTicketProxy->GetAuthTicket(szTicket, sizeof(szTicket) - 1) == false)
		{
			ASSERT(false);
			return "";
		}
		
		//DLOG("GetNewMessengerTicket : %s : %d", szTicket, strlen(szTicket));
		SetMessengerTicket(szTicket);
		
		return GetMessengerTicket();
	}
	else
	{
		//ASSERT(false);
	}
	return "";
}

bool CMessengerActor::IsValidLoginState(void)
{
	GTMessengerActorState state = GetActorState();
	switch (state) 
	{
	case masLoginOK:
	case masReloginOK:
		return true;
	default:
		return false;
	}

	return false;
}	

void CMessengerActor::_OnLoginEnd(void)
{
	if(m_bReloginOKFlag)
	{
		SetActorState(masReloginOK);
		
		SetActorState(masLoginOK, false, false);
        
        m_bReloginWorking = false;
	}
	else
	{
		m_sLoginErrorData.Clear();

//		GT_STOP_WATCH(g_nInternalPresetStopWatch1, "LOGIN OK");
		
		// !
		m_sLoginErrorData.eErrorCode = lirtNone;
		
		GT_API_SPEC_DATA sSpecInfo;
		GetSpecInfo(sSpecInfo);

		if(sSpecInfo.nIntervalPingToLoginServer <= 0)	
			m_pNpMsgr->SetPingSettting(false, 0);
		else
			m_pNpMsgr->SetPingSettting(true, sSpecInfo.nIntervalPingToLoginServer);

		m_pNpMsgr->GetMainServer_SessionDispatcher()->Register_INCOMING_REQUEST_PACKET_Handler(MSNG_CMD_ACTIVEADDBNOTIFY, this );
		m_pNpMsgr->GetMainServer_SessionDispatcher()->Register_CToC_PACKET_Handler(CToC_MOBILE_ADDRESSBOOK_UPDATED, this );
		
		m_pNpMsgr->InitOnlineStatus( ST_ONLINE );
		
		_ConvertMyStatus(m_pNpMsgr->GetNpMsgrUser()->OnlineStatus());
		
		SetActorState(masLoginOK);
		
//		GT_STOP_WATCH(g_nInternalPresetStopWatch2, "TOTAL LOGIN OK");
//		GT_STOP_WATCH(g_nInternalPresetStopWatch3, "TOTAL WAS LOGIN OK");
	}
}


void CMessengerActor::GetMyMobileUserProfile(GT_MOBILE_USER_PROFILE_DATA &sData)
{
    m_sMyUserData.sMyPage.sMobileUserProfile.Convert(sData);
}


void CMessengerActor::GetMyUserProfile(GT_USER_PROFILE_DATA &sData)
{
	sData.eInviteAllowType = m_sMyUserData.sMyPage.eInviteAllowType;
	sData.strTalkIntro = m_sMyUserData.sMyPage.strTalkIntro.c_str();
	sData.strTalkName = m_sMyUserData.sMyPage.strTalkName.c_str();
	sData.strUserID = m_sMyUserData.strUserID.c_str();
	sData.strProfileImageName = m_sMyUserData.sMyPage.strProfileImageName.c_str();
	sData.dwProfileImageCRC = m_sMyUserData.sMyPage.dwProfileImageCRC;
}

void CMessengerActor::GetUserLevels(NE_LEVEL_DATA_LIST &sLevels)
{
	sLevels = m_sLevelList;
}

void CMessengerActor::RequestSendPing(void)
{
	// KEH_API
	// ʹ  Ƽ α׺Ⱑ !
//	//CGTLifeLog log(__FUNCTION__);

	if(m_pNpMsgr)
		m_pNpMsgr->SendSessionControlPacket();
}

bool CMessengerActor::RequestPing(void)
{
	if(m_pNpMsgr == NULL)
		return true;

	return m_pNpMsgr->SendPing();
}


unsigned int CMessengerActor::GetLaunchingResult(void)
{
    if(m_pNpMsgr)
    {
        return m_pNpMsgr->GetNpMsgrUser()->LaunchingCheckResult();
    }
    return 0;
}


LPCSTR CMessengerActor::GetLaunchingInfoURL(void)
{
    if(m_pNpMsgr)
    {
        return m_pNpMsgr->GetNpMsgrUser()->LaunchingResultURL();
    }
    return NULL;
}


void CMessengerActor::DisconnectLoginServer(void)
{
	OutputDebugString(_T("\r\n##### CMessengerActor::DisconnectLoginServer #####"));
	m_bLoginWorking = false;
    m_bReloginWorking = false;
	
//	if(IsEverLoginSuccess())
//	{
//		m_sMyUserData.eLoginState = masReloginReady;
//	}
//	else
//	{
//		m_sMyUserData.eLoginState = masLoginReady;
//	}
    
    SetActorState(masDisconnected);
	
	if(m_pNpMsgr)
		m_pNpMsgr->Disconnect();
}

bool CMessengerActor::RequestRelogin(void)
{
	//NTALK_LOG->Debug(L"[LOGIN] RequestRelogin Start");

	ASSERT(m_pNpMsgr);
	
    m_bReloginWorking = true;
    
	SetActorState(masReloginReady);
	
	return m_pNpMsgr->Relogin();
}


bool CMessengerActor::RequestLogin(LPCWSTR tcsUserID, LPCWSTR tcsPassword, LPCWSTR tcsLangCode, LPCWSTR tcsTenantName,
								   bool bShowOfflineLogin/* = false */, 
								   LPCWSTR tcsLoginCode/* = _T("") */, 
								   LPCWSTR tcsTicketType/* = _T("") */,
								   GTOSType eOSType /* = osWindows */,
								   USHORT usCountryCode/* = 82 */, LPCSTR strMobileNumber/* = "" */, 
								   LPCSTR strMobileToken/* = "" */, 
								   GTMobileOverwriteDataType eOverwriteDataType/* = mobileOverwriteData_Check */)
{
	//CGTLifeLog log(__FUNCTION__);
	
//	GT_STOP_WATCH(g_nInternalPresetStopWatch2, "TOTAL LOGIN START");
//	GT_STOP_WATCH(g_nInternalPresetStopWatch4, "GLS LOGIN START");
	

	USES_CONVERSION; // for T2CA

	if(tcsUserID == NULL)
	{
		//NTALK_LOG->Debug(L"FAIL RequestLogin : UserID IS NULL");
		return false;
	}

	// α û ѹ !!
	if(m_bLoginWorking)
	{
		//NTALK_LOG->Debug(L"FAIL RequestLogin : Already requested login");
		return false;
	}

	// ̹ α  쿡 !
	if(m_sMyUserData.eLoginState == masLoginOK)
	{
		//NTALK_LOG->Debug(L"FAIL RequestLogin : Already login-state is OK");
		return false;
	}

	SetActorState(masLoginReady);

	m_sMyUserData.eIptStatusType = iptstNA;

	m_bLoginWorking = true;

	bool bRet = false;

	m_sMyUserData.eLoginState = masConnecting;

	if (m_sMyUserData.strUserID.empty())
		m_sMyUserData.strUserID = tcsUserID;	// tcsUserID ڰ αν Է ID,  uniq id ƴϴ.

	m_sMyUserData.strLangCode = tcsLangCode;
	m_sMyUserData.strTenantName = tcsTenantName;
	
//	m_log.Clear();
//	m_log.Trace(_T("GLS LOGIN START : ADDR = %s:%d, USERID = %s"), 
//		GT_GLOBAL->GetEnvironment().sLoginServerAddress.strAddress.c_str(), 
//		GT_GLOBAL->GetEnvironment().sLoginServerAddress.nPort, 
//		GetUserID());
	
	//  ̸,
	if(StringUtil::IsEmpty(tcsPassword) == false)
	{
		// Ƽ  ʱȭ Ű!
		m_pNpMsgr->GetNpMsgrUser()->ClearAuthCookie();
	}
	else
	{
		GetNewMessengerTicket();
	}

	// JS   DLL ѱ!
	m_pNpMsgr->SetLoginServerAddress(GT_GLOBAL->GetEnvironment().sLoginServerAddress.strAddress.c_str(), 
	                                 GT_GLOBAL->GetEnvironment().sLoginServerAddress.nPort);

	bRet = m_pNpMsgr->Login(tcsUserID, T2CA(tcsPassword), T2CA(tcsLoginCode), T2CA(tcsTicketType), (USHORT)eOSType);								
	if( bRet != true )
	{
		m_bLoginWorking = false;
		SetActorState(masLoginFailed);
		return bRet;
	}

	m_eOSType = eOSType;
	
	//NTALK_LOG->Debug(L"[LOGIN] RequestLogin result is %s", bRet ? L"TRUE" : L"FALSE");

	return bRet;
}

 
bool CMessengerActor::RequestLogout(GTLogoutReasonType logout_type)
{
	//CGTLifeLog log(__FUNCTION__);
	//NTALK_LOG->Debug(L"[LOGIN] RequestLogout %d", logout_type);

	bool bNotify = true;

	//  쿣 JSʹ α  WAS۾  .
	// ̶ α а 
	// JS α׾ƿ ۾ ݵ ؾ.
    if(_IsLoginProgress())
    {
        GT_ASSERT(m_pNpMsgr);
        m_pNpMsgr->Logout();        
    }

	//   ۾  α  쿡 ó!
	if(!IsEverLoginSuccess())
		return false;

	m_eLogoutType = logout_type;

	// α ƿ   ˷ α׾ƿ  ؾ  ϵ Ѵ.
	SetActorState(masLogoutReady, true, true); //  ȣ  Ƽ 

	//  α׾ƿ ..
	SetActorState(masLogoutProgress, true, true); 

	LogoutJob(logout_type);

	if( logout_type == lortByDisconnect || logout_type == lortByPowerHibernate )
		SetActorState(masReloginFailed);
	else if( logout_type == lortByTicketRefreshFail )
		SetActorState(masFreshTicketFailed);
	else
		SetActorState(masLogoutOK);

	return true;
}

void CMessengerActor::LogoutJob(GTLogoutReasonType logout_type)
{
//	CGTLifeLog log("%s : REASON = %d", __FUNCTION__, logout_type);

	m_pNpMsgr->GetMainServer_SessionDispatcher()->Deregister_INCOMING_REQUEST_PACKET_Handler(MSNG_CMD_ACTIVEADDBNOTIFY);
	m_pNpMsgr->GetMainServer_SessionDispatcher()->Deregister_CToC_PACKET_Handler(CToC_MOBILE_ADDRESSBOOK_UPDATED, this);

	RequestSetMyStatus(ustOFFLINE);
	
	GT_NOTI_PROXY->Clear();

	if( logout_type == lortByMsgrLoginFail )
	{
		GT_ASSERT( m_pNpMsgr->GetNpMsgrUser()->LoginStatus() != LS_LOGIN_READY );
		GT_ASSERT( m_pNpMsgr->GetNpMsgrUser()->LoginStatus() != LS_LOGIN_COMPLETE );
		// ̰쿣 m_pNpMsgr->Logout(); θ ..
	}
	else
	{	
//		log.Tick(_T("NPMSGR LOGOUT"));	

        m_pNpMsgr->Logout();
	}

	// ģ/׷  .
	// ׷/Ʈ ޴  GLS ŶŽ ־
	m_mapEmployee.clear();
	_ClearBuddyList();
	_ClearBuddyPersistMap();
	_ClearBuddyGroupList();
	
	m_bIsEverLoginOKFlag = false;
}


void CMessengerActor::SetMobileUserProfile(const P_GT_MOBILE_USER_PROFILE_DATA &profile)
{
    m_sMyUserData.sMyPage.sMobileUserProfile = profile;
}

void CMessengerActor::SetUserProfile(const P_GT_USER_PROFILE_DATA &profile)
{
	m_sMyUserData.sMyPage.eInviteAllowType = profile.eInviteAllowType;
	
	m_sMyUserData.sMyPage.strTalkName = profile.strTalkName;
	m_sMyUserData.sMyPage.strTalkIntro = profile.strTalkIntro;
}

void CMessengerActor::SetProfileImageData(const GT_PROFILE_IMAGE_DATA &image)
{
	m_sMyUserData.sMyPage.dwProfileImageCRC = image.dwCRC;	
}


void CMessengerActor::SendMyTalkName(LPCWSTR pszTalkName)
{
	m_pNpMsgr->ChangeNick(pszTalkName);
}

void CMessengerActor::RequestRegiFavoriteToPOI(std::vector<std::wstring> &vecUsers, USHORT nUserGrp)
{
	if( vecUsers.empty() )
	{
//		CGTLifeLog log("%s: vecUsers is empty!", __FUNCTION__);
		return;
	}

	if( GetActorState() == masDisconnected )
		RequestRelogin();

//	CGTLifeLog log("%s", __FUNCTION__);

	m_pNpMsgr->RegiFavoriteToPOI(vecUsers, nUserGrp);
}

void CMessengerActor::RequestUregFavoriteFromPOI(USHORT nUserGrp)
{
//	CGTLifeLog log("%s", __FUNCTION__);

	if( GetActorState() == masDisconnected )
		RequestRelogin();

	m_pNpMsgr->UregFavoriteFromPOI(nUserGrp);
}

void CMessengerActor::RequestUregFavoriteFromPOI(std::vector<std::wstring> &vecUsers, USHORT nUserGrp)
{
//	CGTLifeLog log("%s", __FUNCTION__);

	if( GetActorState() == masDisconnected )
		RequestRelogin();

	m_pNpMsgr->UregFavoriteFromPOI(nUserGrp);
}

void CMessengerActor::RequestSetMyStatus(GTUserStatusType eUsertype, bool bForceMode, const char *pCustomData, int nCustomDataSize, bool bCustomDataDBSave)
{
//	CGTLifeLog log("%s : TYPE = %d, FORCE = %d, CUSTUM SIZE = %d, DBSAVE = %d", __FUNCTION__, (int)eUsertype, bForceMode, nCustomDataSize, bCustomDataDBSave);

	if( GetActorState() == masDisconnected )
		RequestRelogin();

	if(bForceMode == false && m_sMyUserData.eUserStatusType == eUsertype)
		return;

	m_sMyUserData.eUserStatusType = eUsertype;
	E_MSGR_ONLINE_STATUS eRealStatus = (E_MSGR_ONLINE_STATUS)eUsertype;

	m_pNpMsgr->ChangeOnlineStatus(eRealStatus, pCustomData, nCustomDataSize, bCustomDataDBSave);
}

void CMessengerActor::RequestGetBuddyStatus(std::vector<wstring> &vecUsers)
{
//	CGTLifeLog log("%s", __FUNCTION__);

	if( GetActorState() == masDisconnected )
		RequestRelogin();

	m_pNpMsgr->GetBuddyStatus(vecUsers);
}


// NpMsgr DLL ϴ  Ͽ Ѵ. 
void CMessengerActor::_ConvertMyStatus(E_MSGR_ONLINE_STATUS eUsertype)
{
	GTUserStatusType eRealStatus = (GTUserStatusType)eUsertype;

	//  ϰ NPMsgr û ʴ´!
	if(m_sMyUserData.eUserStatusType == eRealStatus)
		return;

	m_sMyUserData.eUserStatusType = eRealStatus;
}



int CMessengerActor::_ConvertBuddyUserUpdateType(int nUpdateType)
{
	int nType = 0;

	if(nUpdateType & eBA_LOGIN)
		nType |= buutLogin;
	if(nUpdateType & eBA_NICK)
		nType |= buutTalkName;
	if(nUpdateType & eBA_STATUS)
		nType |= buutStatus;
	if(nUpdateType & eBA_IPT)
		nType |= buutIPT;

	if(nType == 0)
		nType = buutEtc;

	return nType;
}

void CMessengerActor::SetActorState(GTMessengerActorState state, bool bNotify, bool bDirectNotify)
{
	if(m_sMyUserData.eLoginState == state)
		return;

	switch(state)
	{
        case masReloginOK:
        case masLoginOK:
        case masLoginFailed:
		case masReloginFailed:
		case masFreshTicketFailed:
            m_bLoginWorking = false;
            break;
        default:
            break;
	}

	//CGTNormLog log("%s : STATE = %d", __FUNCTION__, state);

//    DLOG(">> ------------------------------------------\n");
//	DLOG(">> CMessengerActor::SetActorState %d\n", state);
//    DLOG(">> ------------------------------------------\n");
	
	//NTALK_LOG->Debug(L"[LOGIN] SetActorState %d", state);
	
	m_sMyUserData.eLoginState = state;

	if(bNotify)
	{
		// If this is main thread, don't need to notify on async-mode.. 
		if(GetMainThreadID() == GetCurrentThreadId())
			bDirectNotify = true;

		if(bDirectNotify)
		{
			CLoginStateNotifyCommand cCommand(this, state);
			cCommand.Execute();
		}
		else
		{
			CLoginStateNotifyCommand *pCommand = CLoginStateNotifyCommand::Create(this, state);
			if(pCommand)
				pCommand->ExecuteAsync();
		}
	}
}


void CMessengerActor::SetMessengerTicketType(LPCSTR strType)
{
	m_strTicketType = strType;
	
	if(NULL == strType)
		return;
	
	std::string str1 = strType;
	std::string str2;
	std::string ticket;

	const char *strTicket = GetMessengerTicket();
	if(strTicket != NULL && strlen(strTicket) > 0)
	{
		str2 = strTicket;
	}
	
	if(str2.length() > 0)
	{
		// check already attach prefix type..
		int pos = str2.find(str1, 0);
		if(pos == 0)
			return;
		
		ticket  = str1;
		ticket += ":";
		ticket += str2;
		
		m_pNpMsgr->GetNpMsgrUser()->SetAuthCookie( ticket.c_str() );
	}
}


void CMessengerActor::SetMessengerTicket(LPCSTR strTicket)
{
	GT_ASSERT(m_pNpMsgr); 
	
	ASSERT(strTicket);
	
	if(NULL == strTicket)
		return;
	
	std::string str1;
	std::string str2 = strTicket;
	std::string ticket;
		
	const char *type = GetMessengerTicketType();	
	if(type != NULL && strlen(type) > 0)
	{
		str1 = type;
	}
	
	if(str1.length() > 0)
	{
		ticket  = str1;
		ticket += ":";
		ticket += str2;
	}
	else {
		ticket = strTicket;
	}


	m_pNpMsgr->GetNpMsgrUser()->SetAuthCookie( ticket.c_str() );
}


void CMessengerActor::GetMyUserInfo(GT_MY_USER_DATA &data)
{
	m_sMyUserData.Convert(data);
}

size_t CMessengerActor::GetBuddyGroupCount(void)
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);

	if(!IsValidLoginState())
		return 0;
	return m_vecBuddyGroup.size();
}


int CMessengerActor::GetDefaultGroupID(void)
{
	GT_ASSERT(m_nDefaultGroupID >= 0);
	return m_nDefaultGroupID;
}


const IGTBuddyUser* CMessengerActor::GetBuddyInfoFromIndex(int nGroupID, size_t nIndex)
{
	CBuddyGroup *pGroup = _GetBuddyGroupInfo(nGroupID);
	if(pGroup == NULL)
		return NULL;

	return pGroup->GetBuddyInfoFromIndex(nIndex);
}


const IGTBuddyUser* CMessengerActor::GetBuddyInfoFromIndex(size_t nIndex)
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);

	if(nIndex >= m_vecBuddy.size())
		return NULL;

	return m_vecBuddy[nIndex];
}


const IGTBuddyUser* CMessengerActor::GetBuddyInfo(int nBuddyID)
{
	return _GetBuddyInfo(nBuddyID);
}


const IGTBuddyUser* CMessengerActor::GetBuddyInfo(LPCWSTR pszBuddyID)
{
	return _GetBuddyInfo(pszBuddyID);
}

const IGTBuddyUser* CMessengerActor::GetBuddyInfo(LPCWSTR pszBuddyID, int nGroupID)
{
	return _GetBuddyInfo(pszBuddyID, nGroupID);
}

const IGTBuddyUser* CMessengerActor::GetAvailbeBuddyInfo(LPCWSTR pszBuddyID)
{
    const IGTBuddyUser* pBuddy = _GetBuddyInfo(pszBuddyID);
    if (NULL == pBuddy)
    {
        pBuddy = GetBuddyInfoFromPersist(pszBuddyID);
    }
    return pBuddy;
}

const IGTBuddyUser* CMessengerActor::GetBuddyInfoFromPersist(LPCWSTR pszBuddyID)
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);
	buddymap_t::iterator iter = m_mapBuddyPersist.find(pszBuddyID);
	if (iter != m_mapBuddyPersist.end())
	{
		return iter->second;
	}
	return NULL;
}



// ܵ   Ʈ Ͽ ȯѴ.
//   ģ ƴ  ִ.
//   Լ Ưϰ ģ ƴϸ鼭  ܸ  Ʈ ߰Ѵ.
size_t CMessengerActor::GetBlockUserList(GT_BUDDY_DATA_LIST &list)
{
	m_listBlockUserList.clear();

	IBuddy * pBuddy = NULL;
	int nCnt        = 0;
	IBuddyEnum *pBuddies = m_pNpMsgr->GetNpMsgrBuddy()->GetAllBuddys(BTYPE_BL);
	if( pBuddies )
	{
		nCnt = pBuddies->Getlength();

		for(int i = 0; i < nCnt; i++)
		{
			GT_BUDDY_DATA sBuddyInfo;
			memset(&sBuddyInfo, 0x0, sizeof(sBuddyInfo));

			pBuddy = pBuddies->Getitem(i);
			if (pBuddy == NULL)
				continue;

			CBuddyUser *pBuddyUser = _GetBuddyInfo(pBuddy);

			// ģ̸鼭 ܵ 
			if(pBuddyUser)
			{
				pBuddyUser->GetData(sBuddyInfo);
			}
			// ģ ƴϴ.
			else
			{
				CBuddyUser::CollectBuddyInfo(pBuddy, sBuddyInfo);
			}

			m_listBlockUserList.push_back(sBuddyInfo);
		}

		pBuddies->Delete();
	}

	list.nSize = m_listBlockUserList.size();
	list.pList = list.nSize > 0? &m_listBlockUserList[0] : NULL;

	return m_listBlockUserList.size();
}


size_t CMessengerActor::GetBuddyCount(void)
{
	if(!IsValidLoginState())
		return 0;

	nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);
	return m_vecBuddy.size();
}


bool CMessengerActor::IsBlockBuddy(LPCWSTR pszBuddyID)
{
	m_listBlockUserList.clear();
	
	bool bFind = false;
	IBuddy * pBuddy = NULL;
	int nCnt        = 0;
	IBuddyEnum *pBuddies = m_pNpMsgr->GetNpMsgrBuddy()->GetAllBuddys(BTYPE_BL);
	
	if( pBuddies )
	{
		nCnt = pBuddies->Getlength();
		
		for(int i = 0; i < nCnt; i++)
		{
			pBuddy = pBuddies->Getitem(i);
			if (pBuddy == NULL)
				continue;
	
			if(StringUtil::StrCompare(pBuddy->Id(), pszBuddyID) == 0)
			{
				bFind = true;
				break;
			}
		}
		
		pBuddies->Delete();
	}
	
	return bFind;
}


bool CMessengerActor::FindBuddy(LPCWSTR pszBuddyID, BYTE type)
{
	int nCount = 0;
    nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);
    
	buddyvector_t::iterator it = m_vecBuddy.begin();
	for (; it != m_vecBuddy.end(); ++it)
	{
		CBuddyUser *pUser = (*it);
		if( (pUser->GetType() & type) && StringUtil::StrCompare(pUser->GetUserID(), pszBuddyID) == 0)
			return true;
	}
	
	if(type & btBlock)
	{
		return IsBlockBuddy(pszBuddyID);
	}
	
	return false;
}


size_t CMessengerActor::GetBuddyCount(int nGroupID)
{
	if(!IsValidLoginState())
		return 0;

	CBuddyGroup *pBuddyGroup = _GetBuddyGroupInfo(nGroupID);
	if(pBuddyGroup)
		return pBuddyGroup->GetBuddyCount();
	return 0;
}


const IGTBuddyGroup* CMessengerActor::GetBuddyGroupInfoFromIndex(size_t nIndex)
{
	if(nIndex >= m_vecBuddyGroup.size())
		return NULL;

	return m_vecBuddyGroup[nIndex];
}


const IGTBuddyGroup* CMessengerActor::GetBuddyGroupInfo(int nGroupID)
{
	return _GetBuddyGroupInfo(nGroupID);
}


const IGTBuddyGroup* CMessengerActor::GetBuddyGroupInfo(LPCWSTR strGroupName)
{
	return _GetBuddyGroupInfo(strGroupName);
}


CBuddyUser * CMessengerActor::_GetBuddyInfo(int nBuddyID)
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);

	buddyvector_t::iterator it = m_vecBuddy.begin();
	for (; it != m_vecBuddy.end(); ++it)
	{
		if((*it)->GetID() == nBuddyID)
		{
			return (*it);
		}
	}
	return NULL;
}

CBuddyUser * CMessengerActor::_GetBuddyInfo(int nBuddyID, int nGroupID)
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);

	buddyvector_t::iterator it = m_vecBuddy.begin();
	for (; it != m_vecBuddy.end(); ++it)
	{
		if( ((*it)->GetID() == nBuddyID) &&
			((*it)->GetGroupID() == nGroupID) )
		{
			return (*it);
		}
	}
	return NULL;
}

CBuddyUser * CMessengerActor::_GetBuddyInfo(IBuddy *pBuddy)
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);

	buddyvector_t::iterator it = m_vecBuddy.begin();
	for (; it != m_vecBuddy.end(); ++it)
	{
		if((*it)->GetBuddyPtr() == pBuddy)
		{
			return (*it);
		}
	}
	return NULL;
}

std::vector<CBuddyUser *> CMessengerActor::_GetBuddyInfoAllGroup(IBuddy *pBuddy)
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);

	std::vector<CBuddyUser *> vecBuddyInfo;

	buddyvector_t::iterator it = m_vecBuddy.begin();
	for (; it != m_vecBuddy.end(); ++it)
	{
		if((*it)->GetBuddyPtr() == pBuddy)
		{
			vecBuddyInfo.push_back(*it);
		}
	}

	return vecBuddyInfo;
}

CBuddyUser * CMessengerActor::_GetBuddyInfo(LPCWSTR pszBuddyID)
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);

	buddyvector_t::iterator it = m_vecBuddy.begin();
	for (; it != m_vecBuddy.end(); ++it)
	{
		if(StringUtil::StrCompare((*it)->GetUserID(), pszBuddyID) == 0)
		{
			return (*it);
		}
	}
	return NULL;
}

CBuddyUser * CMessengerActor::_GetBuddyInfo(LPCWSTR pszBuddyID, int nGroupID)
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);

	buddyvector_t::iterator it = m_vecBuddy.begin();
	for (; it != m_vecBuddy.end(); ++it)
	{
		if( (StringUtil::StrCompare((*it)->GetUserID(), pszBuddyID) == 0) &&
			((*it)->GetGroupID() == nGroupID) )
		{
			return (*it);
		}
	}
	return NULL;
}


CBuddyGroup * CMessengerActor::_GetBuddyGroupInfo(int nGroupID)
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);
	
	buddygroupvector_t::iterator it = m_vecBuddyGroup.begin();
	for (; it != m_vecBuddyGroup.end(); ++it)
	{
		if((*it)->GetID() == nGroupID)
		{
			return (*it);
		}
	}
	return NULL;
}


CBuddyGroup * CMessengerActor::_GetBuddyGroupInfo(LPCWSTR pszGroupName)
{
	buddygroupvector_t::iterator it = m_vecBuddyGroup.begin();
	for (; it != m_vecBuddyGroup.end(); ++it)
	{
		if(StringUtil::StrCompare((*it)->GetName(), pszGroupName) == 0)
		{
			return (*it);
		}
	}
	return NULL;
}

LPCWSTR CMessengerActor::_GetBuddyID(int bBuddyID)
{
	CBuddyUser *pBuddyUser = _GetBuddyInfo(bBuddyID);
	if(pBuddyUser == NULL)
		return NULL;

	return pBuddyUser->GetUserID();
}

LPCWSTR CMessengerActor::_GetBuddyID(int bBuddyID, int nGroupID)
{
	CBuddyUser *pBuddyUser = _GetBuddyInfo(bBuddyID, nGroupID);
	if(pBuddyUser == NULL)
		return NULL;

	return pBuddyUser->GetUserID();
}

int CMessengerActor::_GetBuddyGroupID(int bBuddyID)
{
	CBuddyUser *pBuddyUser = _GetBuddyInfo(bBuddyID);
	if(pBuddyUser == NULL)
		return NULL;

	return pBuddyUser->GetGroupID();
}

CBuddyUser * CMessengerActor::_CreateBuddyInfo(IBuddy *pBuddy)
{
	CBuddyUser *pUser = new CBuddyUser(pBuddy);
	return pUser;
}
	

CBuddyGroup * CMessengerActor::_CreateBuddyGroupInfo()
{
	CBuddyGroup *pGroup = new CBuddyGroup(this);
	return pGroup;
}

bool CMessengerActor::_SetBuddyInPersistMap(CBuddyUser* pSrcBuddyUser)
{
	bool bRet = false;
	ATLASSERT(pSrcBuddyUser);
	if (!pSrcBuddyUser)
	{
		return false;
	}

    if (m_sMyUserData.strUserID == pSrcBuddyUser->GetUserID())
    {
        return false; //don't add self
    }

	nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);
	CBuddyUser *pBuddyUser = NULL;
	GT_BUDDY_DATA sBuddyInfo;// = {0};
	sBuddyInfo.SetGroupID(INT_MIN);
	BOOL bNew = FALSE;

	buddymap_t::iterator iterPersist = m_mapBuddyPersist.find(pSrcBuddyUser->GetUserID());
	if (iterPersist == m_mapBuddyPersist.end())
	{
		pBuddyUser = _CreateBuddyInfo(pSrcBuddyUser->GetBuddyPtr());
		bNew = TRUE;
	}
	else
	{
		pBuddyUser = iterPersist->second;
	}

	if (NULL == pBuddyUser)
	{
		return false;
	}

	pBuddyUser->CollectData();
	pSrcBuddyUser->GetData(sBuddyInfo);
	pBuddyUser->SetData(sBuddyInfo);

	pBuddyUser->SetTalkName(sBuddyInfo.GetTalkName());
	

	if (bNew)
	{
		m_mapBuddyPersist.insert(buddymap_t::value_type(pBuddyUser->GetUserID(), pBuddyUser));
	}
	
	return true;
}

bool CMessengerActor::_SetBuddyInPersistMap(LPCWSTR pszBuddyID, const NE_MEMBER_DATA& memberData)
{
    //TODO:now FavoriteController::CheckEffectiveBubbys will depends this, so restore it now
    //-- delete it later and then fix all the abnormal use

	//for OnGTWASActor_ResponseGetEmployeeInfo(reitSingleTrans)
    if (m_sMyUserData.strUserID == pszBuddyID)
    {
        return false; //don't add self
    }

    nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);
    CBuddyUser* pBuddyAlreadyExist = _GetBuddyInfo(pszBuddyID);
    if (pBuddyAlreadyExist)
    {
        _SetBuddyInPersistMap(pBuddyAlreadyExist);
        return true;
    }
    else
    {
        CBuddyUser *pBuddyUser = NULL;
        GT_BUDDY_DATA sBuddyInfo ;//= {0};
        sBuddyInfo.SetGroupID(INT_MIN);
        BOOL bNew = FALSE;

        buddymap_t::iterator iterPersist = m_mapBuddyPersist.find(pszBuddyID);
        IBuddy *pBuddy = NULL;
        if (iterPersist == m_mapBuddyPersist.end())
        {
            INpMsgrBuddy *pNpMsgrBuddy = m_pNpMsgr->GetNpMsgrBuddy();
            if(pNpMsgrBuddy)
            {
                pBuddy = pNpMsgrBuddy->FindBuddy(pszBuddyID);
            }
            pBuddyUser = _CreateBuddyInfo(pBuddy);
            sBuddyInfo.SetUserID(pszBuddyID);
            bNew = TRUE;
        }
        else
        {
            pBuddyUser = iterPersist->second;
            pBuddyUser->GetData(sBuddyInfo);
        }
        if (NULL == pBuddyUser)
        {
            return false;
        }

        sBuddyInfo.SetName(memberData.strName.c_str());
        sBuddyInfo.SetTalkName(memberData.strNickName.c_str());
        
        //GetEmployeeInfo will not response status, so set it to the default value
        DWORD dwFlags = sBuddyInfo.GetFlags();
        if ((dwFlags & GT_BUDDY_DATA_FLAG_ESTATUS) == 0)
        {
            sBuddyInfo.SetStatus(ustOFFLINE);
        }
        if ((dwFlags & GT_BUDDY_DATA_FLAG_IPTSTATUS) == 0)
        {
            sBuddyInfo.SetIPTStatus(iptstNA);
        }

        //if (pBuddyUser->GetBuddyPtr() == NULL && pBuddy!= NULL)
        //{
        //	pBuddyUser->SetBuddyPtr(pBuddy);
        //}
        pBuddyUser->SetData(sBuddyInfo);
        pBuddyUser->CollectData();

        if (bNew)
        {
            m_mapBuddyPersist.insert(buddymap_t::value_type(pBuddyUser->GetUserID(), pBuddyUser));
        }
    }
	return true;
}

bool CMessengerActor::_SetBuddyInPersistMap(LPCWSTR pszBuddyID, int nUserStatus, LPCWSTR wszNick, int nIPTStatus, int nFlag)
{
//#ifdef _DEBUG
//    CAtlString strTemp;
//    strTemp.Format(TEXT("_SetBuddyInPersistMap, buddyID=%s, nUserStatus=%d, nFlag=%d\n"),
//        pszBuddyID, nUserStatus, nFlag);
//    OutputDebugString(strTemp);
//#endif 

    if (m_sMyUserData.strUserID == pszBuddyID)
    {
        return false; //don't add self
    }
	//for NpMsgrBuddy_OnNotBuddyStatusChanged
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);
    CBuddyUser* pBuddyAlreadyExist = _GetBuddyInfo(pszBuddyID);
    if (pBuddyAlreadyExist)
    {
        _SetBuddyInPersistMap(pBuddyAlreadyExist);
        return true;
    }
    else
    {
        CBuddyUser *pBuddyUser = NULL;
        GT_BUDDY_DATA sBuddyInfo;// = {0};
        sBuddyInfo.SetGroupID(INT_MIN);
        BOOL bNew = FALSE;

        buddymap_t::iterator iterPersist = m_mapBuddyPersist.find(pszBuddyID);
        IBuddy *pBuddy = NULL;
        if (iterPersist == m_mapBuddyPersist.end())
        {
            //will not add  -- will call this function for every on line user in organization chart
            INpMsgrBuddy *pNpMsgrBuddy = m_pNpMsgr->GetNpMsgrBuddy();
            if(pNpMsgrBuddy)
            {
                pBuddy = pNpMsgrBuddy->FindBuddy(pszBuddyID);
            }

            //enable add now -- because will not close chat dialog now
            pBuddyUser = _CreateBuddyInfo(pBuddy);
            sBuddyInfo.SetUserID(pszBuddyID);
            bNew = TRUE;
        }
        else
        {
            pBuddyUser = iterPersist->second;
            pBuddyUser->GetData(sBuddyInfo);
        }
        if (NULL == pBuddyUser)
        {
            return false;
        }

        DWORD dwBuddyFlags = sBuddyInfo.GetFlags();

        if(nFlag & NOTIFY_FLAG_PRESENCE)
        {	
            sBuddyInfo.SetStatus((GTUserStatusType)nUserStatus);
        }
        else
        {
            //have not set status, so set it to default value, avoid debug assert
            if ((dwBuddyFlags & GT_BUDDY_DATA_FLAG_ESTATUS) == 0)
            {
                sBuddyInfo.SetStatus(ustOFFLINE);
            }
        }
        if(nFlag & NOTIFY_FLAG_NICK)
        {					
            sBuddyInfo.SetTalkName(wszNick);
            _UpdateNickName(pszBuddyID, wszNick);
        }

        if( nFlag & NOTIFY_FLAG_IPT )
        {
            sBuddyInfo.SetIPTStatus((NTIPTStatusType)nIPTStatus);
        }
        else{
            //have not set ipt status, so set it to default value, avoid debug assert
            if ((dwBuddyFlags & GT_BUDDY_DATA_FLAG_IPTSTATUS) == 0)
            {
                sBuddyInfo.SetIPTStatus(iptstNA);
            }
        }

        //if (pBuddyUser->GetBuddyPtr() == NULL && pBuddy!= NULL)
        //{
        //	pBuddyUser->SetBuddyPtr(pBuddy);
        //}
        pBuddyUser->SetData(sBuddyInfo);
        pBuddyUser->CollectData();

        if (bNew)
        {
            m_mapBuddyPersist.insert(buddymap_t::value_type(pBuddyUser->GetUserID(), pBuddyUser));
        }
    }


	return true;
}

bool CMessengerActor::_MoveGroupBuddyInfo(CBuddyUser *pUser, int nFromGroupID, int nToGroupID)
{
	CBuddyGroup *pGroupFrom = _GetBuddyGroupInfo(nFromGroupID);
	CBuddyGroup *pGroupTo = _GetBuddyGroupInfo(nToGroupID);

	if(!pGroupFrom || !pGroupTo)
		return false;

	if(pGroupFrom)
	{
		pGroupFrom->DelBuddyUser(pUser);
	}

	if(pGroupTo)
	{
		pUser->SetGroupID(nToGroupID);
		pGroupTo->AddBuddyUser(pUser);
	}

	return true;
}


bool CMessengerActor::_EraseBuddyInfo(IBuddy *pBuddy)
{	
    nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);
    
	buddyvector_t::iterator it = m_vecBuddy.begin();
	for (; it != m_vecBuddy.end(); ++it)
	{
		CBuddyUser *pBuddyUser = (*it); 
		if(pBuddyUser->GetBuddyPtr() == pBuddy)
		{
			// ׷캰 𸮽Ʈ ؾ
			CBuddyGroup *pBuddyGroup = _GetBuddyGroupInfo(pBuddyUser->GetGroupID());
			if(pBuddyGroup)
			{
				pBuddyGroup->DelBuddyUser(pBuddyUser);
			}
			//buddymap_t::iterator iterPersist = m_mapBuddyPersist.find(pBuddyUser->GetUserID());
			//if (iterPersist != m_mapBuddyPersist.end())
			//{
			//	iterPersist->second->ReleaseUser();
			//	m_mapBuddyPersist.erase(iterPersist);
			//}

			pBuddyUser->ReleaseUser();
			m_vecBuddy.erase(it);
			return true;
		}
	}
	return false;
}

bool CMessengerActor::_EraseBuddyInfo(LPCWSTR pszBuddyID, int nGroupID)
{
	
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);
    
	buddyvector_t::iterator it = m_vecBuddy.begin();
	for (; it != m_vecBuddy.end(); ++it)
	{
		CBuddyUser *pBuddyUser = (*it); 
		
		if( (StringUtil::StrCompare(pBuddyUser->GetUserID(), pszBuddyID) == 0) && 
			(pBuddyUser->GetGroupID() == nGroupID) )
		{
			// ׷캰 𸮽Ʈ ؾ
			CBuddyGroup *pBuddyGroup = _GetBuddyGroupInfo(pBuddyUser->GetGroupID());
			if(pBuddyGroup)
			{
				pBuddyGroup->DelBuddyUser(pBuddyUser);
			}

			pBuddyUser->ReleaseUser();
			m_vecBuddy.erase(it);
			return true;
		}
	}
	
	return false;
}


CBuddyGroup * CMessengerActor::_EraseBuddyGroupInfoWithoutDelete(int nID)
{
	buddygroupvector_t::iterator it = m_vecBuddyGroup.begin();
	for (; it != m_vecBuddyGroup.end(); ++it)
	{
		if((*it)->GetID() == nID)
		{						
			CBuddyGroup *pGroup = *it;
			m_vecBuddyGroup.erase(it);
			
			pGroup->ReleseGroup();
		}
	}
	return NULL;
}


bool CMessengerActor::_EraseBuddyGroupInfo(int nID)
{
	buddygroupvector_t::iterator it = m_vecBuddyGroup.begin();
	for (; it != m_vecBuddyGroup.end(); ++it)
	{
		if((*it)->GetID() == nID)
		{						
			(*it)->ReleseGroup();
			m_vecBuddyGroup.erase(it);

			return true;
		}
	}
	return false;
}

void CMessengerActor::_AddEmployeeInfo(const NE_MEMBER_DATA_LIST &list)
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);

	for (unsigned int index = 0; index < list.nSize; index++)
	{
		WSTRING strUserId = list.pList[index].strUserId;

		employeemap_t::const_iterator employeeIterator = m_mapEmployee.find(strUserId);
		if (employeeIterator == m_mapEmployee.end())
		{
			m_mapEmployee.insert(std::make_pair(list.pList[index].strUserId, list.pList[index]));
		}
	}
}

void CMessengerActor::_UpdateNickName(LPCWSTR wszUserId, LPCWSTR wszNickName)
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);

	employeemap_t::iterator employeeIterator = m_mapEmployee.find(wszUserId);
	if( employeeIterator == m_mapEmployee.end() )
		return;

	employeeIterator->second.strNickName = wszNickName;
}

bool CMessengerActor::_ReloadBuddyList(const GT_BUDDY_DATA_LIST &listBuddy)
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);
	ATLTRACE(TEXT("CMessengerActor::_ReloadBuddyList\n"));
	
	INpMsgrBuddy *pNpMsgrBuddy = m_pNpMsgr->GetNpMsgrBuddy();
	if(pNpMsgrBuddy == NULL)
		return false;
	
	buddygroupvector_t::iterator it = m_vecBuddyGroup.begin();
	for (; it != m_vecBuddyGroup.end(); ++it)
	{
		(*it)->CleanBuddyUserList();
	}
	_ClearBuddyList();
	//_ClearBuddyPersistMap();  //do not clear buddy in persist map --

	for(size_t i = 0; i < listBuddy.nSize; i++)
	{
		const GT_BUDDY_DATA &sBuddyInfo = listBuddy.pList[i];
		IBuddy *pBuddy = pNpMsgrBuddy->FindBuddy(sBuddyInfo.GetUserID() );
		
		// buddylist  ̺ ִ ?? ==> ܻȲ..
		if (pBuddy == NULL)
		{
			// ģ ƴϴ!!
			continue;
		}
		
		//  
		CBuddyUser *pBuddyUser = _CreateBuddyInfo(pBuddy);
		if (NULL == pBuddyUser)
		{
			continue;
		}

		pBuddyUser->SetData(sBuddyInfo);
		
		// KEH_API
		//   !
		//    
		// 1. αν WASݷ 𸮽Ʈ  
		// 2. ģ     Ƽ ݹ鿡
		// ̷ 2θ Ȯ    ִ.
		// IBuddy ִ Nick() Լ  ׻ ""鸮ϵǰִ.
		//   Ͽ ùٸ  ޽ֵ !
		// ޵ CRoomUser::SetTalkName CollectData Լ ÿ ų ʿ䰡 ִٸ
		// SetTalkNameԼ  Ű!!!
		pBuddyUser->SetTalkName(sBuddyInfo.GetTalkName());
		
		pBuddyUser->CollectData();
		
		//  ģٰ   .
		//  Ŀ ٽ ģ߸ ؼ ģ 
		//  ´ 3̰    ģ̹Ƿ  ¶λ ϰ ȴ.
		//  OFFLINE ƴ϶ wait Ʈ  ģ !
		if(pBuddyUser->GetStatus() != ustOFFLINE && pBuddyUser->IsWait())
		{
			m_pNpMsgr->GetNpMsgrBuddy()->Sync_RemoveWaitBuddy( pBuddyUser->GetUserID() );
		}
		
		CBuddyGroup *pBuddyGroup = _GetBuddyGroupInfo(pBuddyUser->GetGroupID());
		if(pBuddyGroup != NULL)
		{
			if(pBuddyGroup->AddBuddyUser(pBuddyUser) == false)
			{
				// Must be release... pBuddyUser is new created..
				pBuddyUser->ReleaseObject();
				continue;
			}
		}
		else
		{
			pBuddyUser->ReleaseObject();
			continue;

		}
		
        m_vecBuddy.push_back(pBuddyUser);
		_SetBuddyInPersistMap(pBuddyUser);
	}
	
    m_bLoadBuddyList = true;
	
	return true;
}


void CMessengerActor::_CheckValidBuddyList(void)
{
    nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);
    
    INpMsgrBuddy *pNpMsgrBuddy = m_pNpMsgr->GetNpMsgrBuddy();
	if(pNpMsgrBuddy == NULL)
		return;
    
    buddyvector_t::iterator it = m_vecBuddy.begin();
    
	for (; it != m_vecBuddy.end(); )
	{
		CBuddyUser *pBuddyUser = (*it);
        
        IBuddy *pBuddy = pNpMsgrBuddy->FindBuddy(pBuddyUser->GetUserID());
        
		if(pBuddy == NULL)
		{
			// ׷캰 𸮽Ʈ ؾ
			CBuddyGroup *pBuddyGroup = _GetBuddyGroupInfo(pBuddyUser->GetGroupID());
			if(pBuddyGroup)
			{
				pBuddyGroup->DelBuddyUser(pBuddyUser);
			}
            
			pBuddyUser->ReleaseUser();
            it = m_vecBuddy.erase(it);
		}
        else
            it++;
	}

	for (buddymap_t::iterator iterPersist = m_mapBuddyPersist.begin();
		iterPersist != m_mapBuddyPersist.end();)
	{
		CBuddyUser *pBuddyUser = iterPersist->second;
		IBuddy *pBuddy = pNpMsgrBuddy->FindBuddy(pBuddyUser->GetUserID());
		if(pBuddy == NULL)
		{
			pBuddyUser->ReleaseUser();
			m_mapBuddyPersist.erase(iterPersist++);
		}
		else
		{
			iterPersist++;
		}
		
	}
}


bool CMessengerActor::_UpdateBuddyList(const GT_BUDDY_DATA_LIST &listBuddy)
{
    bool bJobSucc = true;
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);
	ATLTRACE(TEXT("CMessengerActor::_UpdateBuddyList\n"));
	
	INpMsgrBuddy *pNpMsgrBuddy = m_pNpMsgr->GetNpMsgrBuddy();
	if(pNpMsgrBuddy == NULL)
		return false;
		
	for(size_t i = 0; i < listBuddy.nSize; i++)
	{
		const GT_BUDDY_DATA &sBuddyInfo = listBuddy.pList[i];
		IBuddy *pBuddy = pNpMsgrBuddy->FindBuddy(sBuddyInfo.GetUserID() );
		
		// buddylist  ̺ ִ ?? ==> ܻȲ..
		if (pBuddy == NULL)
		{
			// ģ ƴϴ!!
			continue;
		}
		
		//  
        int nPrevGroupID = -1;
        CBuddyUser *pBuddyUser = _GetBuddyInfo(sBuddyInfo.GetUserID());
        if(pBuddyUser == NULL)
        {
            pBuddyUser = _CreateBuddyInfo(pBuddy);
			if (NULL == pBuddyUser)
			{
				continue;
			}
        }
        else
        {
            nPrevGroupID = pBuddyUser->GetGroupID();
        }
        
		pBuddyUser->SetData(sBuddyInfo);
		
		// KEH_API
		//   !
		//    
		// 1. αν WASݷ 𸮽Ʈ  
		// 2. ģ     Ƽ ݹ鿡
		// ̷ 2θ Ȯ    ִ.
		// IBuddy ִ Nick() Լ  ׻ ""鸮ϵǰִ.
		//   Ͽ ùٸ  ޽ֵ !
		// ޵ CRoomUser::SetTalkName CollectData Լ ÿ ų ʿ䰡 ִٸ
		// SetTalkNameԼ  Ű!!!
		pBuddyUser->SetTalkName(sBuddyInfo.GetTalkName());
		
		pBuddyUser->CollectData();
		
		//  ģٰ   .
		//  Ŀ ٽ ģ߸ ؼ ģ 
		//  ´ 3̰    ģ̹Ƿ  ¶λ ϰ ȴ.
		//  OFFLINE ƴ϶ wait Ʈ  ģ !
		if(pBuddyUser->GetStatus() != ustOFFLINE && pBuddyUser->IsWait())
		{
			m_pNpMsgr->GetNpMsgrBuddy()->Sync_RemoveWaitBuddy( pBuddyUser->GetUserID() );
		}
        
        if(nPrevGroupID < 0)    // means "new buddy"
        {
            m_vecBuddy.push_back(pBuddyUser);
        }
        else
        {
            CBuddyGroup *pPrevBuddyGroup = _GetBuddyGroupInfo(nPrevGroupID);
            if(pPrevBuddyGroup == NULL)
            {
                pPrevBuddyGroup->DelBuddyUser(pBuddyUser);        
            }
        }

        CBuddyGroup *pBuddyGroup = _GetBuddyGroupInfo(pBuddyUser->GetGroupID());
		if(pBuddyGroup == NULL)
		{
			pBuddyGroup = _GetBuddyGroupInfo(GetDefaultGroupID());
			GT_ASSERT(pBuddyGroup);
		}
        
        if(pBuddyGroup->AddBuddyUser(pBuddyUser) == false)
        {
            GT_ASSERT(nPrevGroupID >= 0);
        }
		_SetBuddyInPersistMap(pBuddyUser);
	}	
	
	return bJobSucc;
}

bool CMessengerActor::_ReloadBuddyGroupList(const GT_BUDDY_GROUP_DATA_LIST &listGroup)
{
	nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);
	
	_ClearBuddyGroupList();

	for(size_t i = 0; i < listGroup.nSize; i++)
	{
		const GT_BUDDY_GROUP_DATA &sGroupInfo = listGroup.pList[i];
		
		//  
		// ̹  ̸ ִ üũ
		if(_GetBuddyGroupInfo(sGroupInfo.strName) != NULL)
			continue;
		
		CBuddyGroup *pBuddyGroup = _CreateBuddyGroupInfo();
		if (NULL != pBuddyGroup)
		{
			pBuddyGroup->SetData(sGroupInfo);
			m_vecBuddyGroup.push_back(pBuddyGroup);		
		}
	}
    
    m_bLoadBuddyList = false;   // MUST BE RELOAD BUDDY!!!
	
	return true;
}


void CMessengerActor::RequestMyPage(void)
{
	//CGTLifeLog log(__FUNCTION__);

	int nInviteSerial = 0;
	int nSpecSerial = 0;
	
    if(_IsLoginProgress())
    {
        SetActorState(masReceivingMyPage);
	}

    // WAS MyPage  Ͽ   .
	int nProfileSerial = 0;
	if(IsMobileLogin())
		nProfileSerial = -1;	// Don't need to recv my profile info (already recv REQ_CMD_LOGIN response packet..)
	
	trid_t trid;
	m_pWASActor->RequestMyPage(true, m_eOSType, m_sMyUserData.strLangCode, m_sMyUserData.strTenantName, nProfileSerial, nInviteSerial, nSpecSerial, &trid);
	_AddMyTransaction(trid);
}


void CMessengerActor::RequestBuddyGroupList(void)
{
	//CGTLifeLog log(__FUNCTION__);
	
	int nGroupSerial = 0;

    if(_IsLoginProgress())
    {
        SetActorState(masReceivingBuddyGroup);
    }

    // ģ  ΰ  WAS  !!
	trid_t trid;
	m_pWASActor->RequestBuddyGroupList(&trid);
	
	_AddMyTransaction(trid);
}


bool CMessengerActor::_IsLoginProgress()
{
    if(m_bReloginWorking)
        return true;
    
 	switch(GetActorState())
	{
        case masLoginReady:
        case masReloginReady:
        case masConnecting:
        case masReceivingMyPage:
        case masReceivingBuddyInfo:
        case masReceivingMobileBlockList:
        case masReceivingBuddyGroup:
            return true;
        default:
            return false;
    }
    return false;
}

void CMessengerActor::RequestBuddyList(bool bForceMode)
{
	//CGTLifeLog log(__FUNCTION__);

	int nBuddySerial = 0;

    if(_IsLoginProgress())
    {
        SetActorState(masReceivingBuddyInfo);
    }
    
	// ģ ׷   WAS  !!		
	trid_t trid;
	if(m_pWASActor->RequestBuddyList(m_sMyUserData.strLangCode.c_str(), nBuddySerial, &trid))
    {
        _AddMyTransaction(trid);
    }
}
void CMessengerActor::RequestUserImageList(LPCTSTR str)
{
	trid_t trid;
	if (m_pWASActor->RequestEmplyeeInfo(str, m_sMyUserData.strLangCode.c_str(), reitGetPhotoURL, &trid))
	{
		_AddMyTransaction(trid);
	}
}

void CMessengerActor::RequestEmployeeInfoList()
{
	const wchar_t* sperator = L"|";
	//CGTLifeLog log(__FUNCTION__);

	GT_ASSERT(m_pNpMsgr);

	std::wstring listUserID;
	{
		nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);
		for (buddyvector_t::const_iterator buddyIterator = m_vecBuddy.begin(); buddyIterator != m_vecBuddy.end(); ++buddyIterator)
		{
			CBuddyUser *pUser = *buddyIterator;
			LPCWSTR strUserID = pUser->GetUserID();

			if (listUserID.empty() == false)
			{
				listUserID.append(sperator);
			}
			listUserID.append(strUserID);
		}

		//add user info from persist
		for (buddymap_t::const_iterator iterPersist = m_mapBuddyPersist.begin(); 
			iterPersist != m_mapBuddyPersist.end();
			++iterPersist)
		{
			CBuddyUser *pUser = iterPersist->second;
			LPCWSTR strUserID = pUser->GetUserID();

			if (listUserID.find(strUserID) == -1)
			{
				if (listUserID.empty() == false)
				{
					listUserID.append(sperator);
				}
				listUserID.append(strUserID);
			}
		}
	}


	trid_t trid;
	if (m_pWASActor->RequestEmplyeeInfo(listUserID.c_str(), m_sMyUserData.strLangCode.c_str(), reitLogin, &trid))
	{
		_AddMyTransaction(trid);
	}
}

void CMessengerActor::RequestRefreshTicket(void)
{
	//CGTLifeLog log(__FUNCTION__);

	trid_t trid;
	m_pWASActor->RequestRefreshTicket();

	_AddMyTransaction(trid);
}

bool CMessengerActor::RequestImportBuddy(std::vector<IMPORT_GROUP> &vecImportBuddy, trid_t *pTrid)
{
	OutputDebugString( _T("CMessengerActor::RequestImportBuddy ===================================\n") );

	std::vector<IMPORT_GROUP>::iterator itr = vecImportBuddy.begin();
	if( itr == vecImportBuddy.end() )
	{
		OutputDebugString( _T("vecImportBuddy is empty ~! ===================================\n") );
		return false;
	}

	m_vecImportBuddy.clear();
	m_vecImportBuddy.assign(vecImportBuddy.begin(), vecImportBuddy.end());

	RequestAddBuddyGroup(m_vecImportBuddy.begin()->strGroupName.c_str(), buddyGroupAction_Import);

	return true;
}

bool CMessengerActor::RequestAddBuddy(int nGroupID, std::vector<wstring> &vecBuddyID, LPCWSTR strInviteMsg, NTAddBuddyType addBuddyType, trid_t *pTrid)
{
	OutputDebugString( _T("CMessengerActor::RequestAddBuddy ===================================\n") );

	const wchar_t* sperator = L"|";

	//CGTLifeLog log(__FUNCTION__);

	GT_ASSERT(m_pNpMsgr);

	if( vecBuddyID.empty() )
		return false;

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;
	
	std::wstring listUserID;
	std::vector<wstring>::const_iterator buddy_iter =  vecBuddyID.begin();
	
	for(; buddy_iter != vecBuddyID.end(); ++buddy_iter)
	{		
		CBuddyUser* pUser = _GetBuddyInfo((*buddy_iter).c_str(), nGroupID);
		if(pUser == NULL)
		{		
			LPCWSTR strUserID = buddy_iter->c_str();
		
			if (listUserID.empty() == false)
				listUserID.append(sperator);
			listUserID.append(strUserID);
		}
	}

	bool bRet = false;
	if(listUserID.empty() == false)
	{
		NTRequestEmpInfoType reitType = reitAddBuddy;
		if( addBuddyType == abtImportBuddy )
			reitType = reitImportBuddy;

		trid_t trid;
		bRet = m_pWASActor->RequestEmplyeeInfo(listUserID.c_str(), m_sMyUserData.strLangCode.c_str(), reitType, &trid, nGroupID);
		
		if (bRet)
		{
			_AddMyTransaction(trid);
			
			if (pTrid)
				*pTrid = trid;
		}
	}

	return bRet;
}


bool CMessengerActor::RequestDelBuddy(std::vector<int> &vecBuddyID, trid_t *pTrid)
{
	//CGTLifeLog log(__FUNCTION__);

	GT_ASSERT(m_pNpMsgr);

	if( vecBuddyID.empty() )
		return false;

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;

	vector< pair<wstring, int> > vecBuddyWithGroupID;
	for( std::vector<int>::iterator itr = vecBuddyID.begin(); itr != vecBuddyID.end(); itr++ )
	{
		std::pair<wstring, int> buddy;
		buddy.first = _GetBuddyID(*itr);
		buddy.second = _GetBuddyGroupID(*itr);
		vecBuddyWithGroupID.push_back(buddy);
	}

	if(vecBuddyWithGroupID.empty())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	bool bRet = m_pNpMsgr->GetNpMsgrBuddy()->Sync_RemoveBuddy( vecBuddyWithGroupID, false, trid.GetID() );
	if(bRet)
		_AddMyTransaction(trid);

	return bRet;
}


bool CMessengerActor::RequestMoveBuddy(std::vector<int> &vecBuddyID, int nNewGrpID, trid_t *pTrid)
{
	//CGTLifeLog log(__FUNCTION__);

	if( vecBuddyID.empty() )
		return false;

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);
	bool bRet = false;

	vector< pair<wstring, int> > vecBuddyWithGroupID;
	for( std::vector<int>::iterator itr = vecBuddyID.begin(); itr != vecBuddyID.end(); itr++ )
	{
		std::pair<wstring, int> buddy;
		buddy.first = _GetBuddyID(*itr);
		buddy.second = _GetBuddyGroupID(*itr);
		vecBuddyWithGroupID.push_back(buddy);
	}

	bRet = m_pWASActor->RequestUpdateBuddy(vecBuddyWithGroupID, nNewGrpID, &trid);

	if(bRet)
		_AddMyTransaction(trid);
	return bRet;
}


bool CMessengerActor::RequestSearchBuddy(LPCWSTR strBuddyID, trid_t *pTrid)
{
	//CGTLifeLog log(__FUNCTION__);

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);
	bool bRet = false;
	
	bRet = m_pWASActor->RequestSearchBuddy(strBuddyID, &trid);

	if(bRet)
		_AddMyTransaction(trid);
	return bRet;
}


bool CMessengerActor::RequestRejectBuddy(LPCWSTR strBuddyID, trid_t *pTrid)
{
	//CGTLifeLog log(__FUNCTION__);

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);
	GT_ASSERT(m_pNpMsgr);

	bool bRet = m_pNpMsgr->GetNpMsgrBuddy()->Sync_RemoveWaitBuddy( strBuddyID, trid.GetID() );
	if(bRet)
	{
		_AddMyTransaction(trid);
		
		// Remove invite list...
		std::vector<P_GT_BUDDY_INVITE_NOTIFY_DATA>::iterator it = m_sMyUserData.sMyPage.vecInviteList.begin();
	
		for( ; it != m_sMyUserData.sMyPage.vecInviteList.end(); it++)
		{
			if((*it).strBuddyID == strBuddyID)
			{
				m_sMyUserData.sMyPage.vecInviteList.erase(it);
				break;
			}
		}
		
		m_sMyUserData.sMyPage.ConvertList();
	}
	return bRet;
}


bool CMessengerActor::RequestAcceptBuddy(LPCWSTR strBuddyID, trid_t *pTrid)
{
	//CGTLifeLog log(__FUNCTION__);

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);
	GT_ASSERT(m_pNpMsgr);

	// ̹ ģ üũ
	CBuddyUser *pBuddyUser = _GetBuddyInfo(strBuddyID);
	if(pBuddyUser)
	{
		return false;
	}

	// ģ   ̹Ƿ ̰쿡 ׷ID ˼ .
	//  ⺻ ׷쿡 ش ģ ߰!
	// =>[ģʴ]  [ģ]  Ŷ ϴ!  򰥸  !
	// ==> [ģʴ]  [ģ]  ϴ 
	// ==> ̹ ޸𸮿 ش ģ  pBuddy Ͱ ִ η Ǻ.
    // ===> ADDBUDDY Ŷ  ,  Ŷ ޾
	// ===> ̹  ޸𸮿   ==> [ģ]
	// ===>   ޸𸮿     ==> [ģʴ]


	//bool bRet = m_pNpMsgr->GetNpMsgrBuddy()->Sync_AddBuddy(GetDefaultGroupID(), strBuddyID, _T(""), trid.GetID());	// Ntalk ģ   ʴ´. HJS
	bool bRet = false;
	if(bRet)
		_AddMyTransaction(trid);
	return bRet;
}


bool CMessengerActor::RequestBlockBuddy(bool bBlock, LPCWSTR strBuddyID, trid_t *pTrid)
{
	//CGTLifeLog log(__FUNCTION__);

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);
	bool bRet = false;
	if(bBlock)
	{
		bRet = m_pNpMsgr->GetNpMsgrBuddy()->Sync_AddBlockBuddy(strBuddyID, trid.GetID());
	}
	else
	{
		bRet = m_pNpMsgr->GetNpMsgrBuddy()->Sync_RemoveBlockBuddy(strBuddyID, trid.GetID());
	}

	if(bRet)
		_AddMyTransaction(trid);

	return bRet;
}


bool CMessengerActor::RequestRefreshWorkStatus( trid_t *pTrid /*= NULL*/ )
{
	GT_ASSERT(m_pNpMsgr);

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;

	const wchar_t* sperator = L"|";
	std::wstring listUserID;
	{
		nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);
		for (buddyvector_t::const_iterator buddyIterator = m_vecBuddy.begin(); buddyIterator != m_vecBuddy.end(); ++buddyIterator)
		{
			CBuddyUser *pUser = *buddyIterator;
			LPCWSTR strUserID = pUser->GetUserID();

			if (listUserID.empty() == false)
			{
				listUserID.append(sperator);
			}
			listUserID.append(strUserID);
		}

		//add user info from persist
		for (buddymap_t::const_iterator iterPersist = m_mapBuddyPersist.begin(); 
			iterPersist != m_mapBuddyPersist.end();
			++iterPersist)
		{
			CBuddyUser *pUser = iterPersist->second;
			LPCWSTR strUserID = pUser->GetUserID();
			if (listUserID.find(strUserID) == -1)
			{
				if (listUserID.empty() == false)
				{
					listUserID.append(sperator);
				}
				listUserID.append(strUserID);
			}
		}
	}


	bool bRet = false;
	if(listUserID.empty() == false)
	{
		NTRequestEmpInfoType reitType = reitRefreshWorkStatus;

		trid_t trid;
		bRet = m_pWASActor->RequestEmplyeeInfo(listUserID.c_str(), m_sMyUserData.strLangCode.c_str(), reitType, &trid);

		if (bRet)
		{
			_AddMyTransaction(trid);

			if (pTrid)
				*pTrid = trid;
		}
	}

	return bRet;

}


bool CMessengerActor::RequestAddBuddyGroup(LPCWSTR strGroupName, GTBuddyAddGroupType addGroupType, int nSortOrder, trid_t *pTrid)
{
	OutputDebugString( _T("CMessengerActor::RequestAddBuddyGroup ===================================\n") );

	//CGTLifeLog log(__FUNCTION__);

	if( wcslen(strGroupName) <= 0 )
		return false;

	// α  쿡 ó!
	if(!IsValidLoginState() && m_sMyUserData.eLoginState != masReceivingBuddyGroup)
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);
	bool bRet = false;
	bRet = m_pWASActor->RequestAddGroup(strGroupName, addGroupType, nSortOrder, &trid);

	if(bRet)
		_AddMyTransaction(trid);
	return bRet;
}

bool CMessengerActor::RequestDelBuddyGroup(int nGroupID, trid_t *pTrid)
{
	//CGTLifeLog log(__FUNCTION__);

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	// ׷  ã 
	vector< pair<wstring, int> > vecBuddy;
	for(size_t index = 0; index < GetBuddyCount(nGroupID); index++)
	{
		const IGTBuddyUser* pBuddyUser = GetBuddyInfoFromIndex(nGroupID, index);
		if(pBuddyUser != NULL)
		{
			std::pair<wstring, int> buddy;
			buddy.first = pBuddyUser->GetUserID();
			buddy.second = nGroupID;
			vecBuddy.push_back(buddy);
		}
	}

	// ãⰡ ִ  ã , ãⰡ   ׷ 
	bool bRet = false;
	if(vecBuddy.empty() == true)
		bRet = m_pWASActor->RequestDelGroup(nGroupID, &trid);
	else
		bRet = m_pNpMsgr->GetNpMsgrBuddy()->Sync_RemoveBuddy(vecBuddy, true, trid.GetID());

	if(bRet)
		_AddMyTransaction(trid);

	return bRet;
}

bool CMessengerActor::RequestUpdateBuddyGroup(int nGroupID, const GT_BUDDY_GROUP_UPDATABLE_DATA &sInfo, trid_t *pTrid)
{
	//CGTLifeLog log(__FUNCTION__);

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	bool bRet = false;
	bRet = m_pWASActor->RequestUpdateGroup(nGroupID, sInfo, &trid);

	if(bRet)
		_AddMyTransaction(trid);
	return bRet;
}

bool CMessengerActor::RequestUpdateBuddyGroupSortOrder(std::vector<GT_BUDDY_GROUP_DATA> &vecGroupData, trid_t *pTrid)
{
	//CGTLifeLog log(__FUNCTION__);

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	bool bRet = false;
	bRet = m_pWASActor->RequestUpdateGroupSortOrder(vecGroupData, &trid);

	if(bRet)
		_AddMyTransaction(trid);
	return bRet;
}




//   ޽ 
bool CMessengerActor::RequestSendUserString(LPCWSTR pszUserID, unsigned int nUserDefinedCommand, LPCWSTR pszUserString)
{
	USES_UTF8_CONVERSION;

	std::string strBuffer;
	if(pszUserString)
		strBuffer = W2U8(pszUserString);
	m_pNpMsgr->SendMessage(nUserDefinedCommand, strBuffer.c_str(), strBuffer.size(), pszUserID);
	return true;
}


bool CMessengerActor::RequestSendUserBuffer(LPCWSTR pszUserID, unsigned int nUserDefinedCommand, const char *pBuffer, int nBufferSize)
{
	m_pNpMsgr->SendMessage(nUserDefinedCommand, pBuffer, nBufferSize, pszUserID);
	return true;
}


bool CMessengerActor::RequestSendMemoEx2(std::vector<LPCWSTR> &vecTargetUserID, LPCWSTR strContents, trid_t *pTrid)
{
	//CGTLifeLog log(__FUNCTION__);

	if( vecTargetUserID.empty() || wcslen(strContents) <= 0 )
		return false;

	if( GetActorState() == masDisconnected )
		RequestRelogin();
	else if(!IsValidLoginState())
		return false;

	INpSessionDispatcher * pDispatcher = NULL;
	pDispatcher = GetNpMsgr()->GetMainServer_SessionDispatcher();

	if(pDispatcher == NULL)
		return false;

	int nIdCounts = vecTargetUserID.size();
//	CGTLifeLog log2("nIdCounts : %d", nIdCounts);	
	if(nIdCounts == 0)
		OutputDebugString(_T("\r\n##### RequestSendMemoEx2 : nIdCounts = 0 #####"));
	else
		OutputDebugString(_T("\r\n##### RequestSendMemoEx2 #####"));

	nfc::CGBStream stream;
	stream.CreateStream();

	// Header...
	stream.Write_U2(nIdCounts);							// User Count...
	vector<LPCWSTR>::iterator iter = vecTargetUserID.begin();
	OutputDebugString(_T("\r\n##### RequestSendMemoEx2...0 #####"));
	for(;iter != vecTargetUserID.end(); ++iter)
	{
		OutputDebugString(_T("\r\n##### RequestSendMemoEx2...1 #####"));
		stream.Write_U8SS_from_Unicode(*iter);			// User ID
		//NTALK_LOG->Debug(L"[CHAT] Invite user:[%s] with message:[%s]", *iter, strContents);
	}
	stream.Write_U1((int)0);
	stream.Write_U8S_from_Unicode(_T(""));				// Subject...
	stream.Write_U8S_from_Unicode(strContents);			// Message

	ULONG uTrid = 0;

	uTrid = pDispatcher->Send_REQUEST_PACKET(MSNG_CMD_SENDMEMOEX, (USHORT)stream.GetDataLen(), stream.GetData(), this);

	if(pTrid)
		*pTrid = uTrid;

	m_listTridForNpMsgr.push_back(uTrid);

	return true;
}

bool CMessengerActor::RequestSendMemo(LPCWSTR strTargetUserID, LPCWSTR strSubject, LPCWSTR strContents, trid_t *pTrid)
{
	//CGTLifeLog log(__FUNCTION__);

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;

	INpSessionDispatcher * pDispatcher = NULL;
	pDispatcher = GetNpMsgr()->GetMainServer_SessionDispatcher();

	if(pDispatcher == NULL)
		return false;

	nfc::CGBStream stream;
	stream.CreateStream();

	// Header...
	stream.Write_U2(1);									// User Count...
	stream.Write_U8SS_from_Unicode(strTargetUserID);	// User ID
	stream.Write_U1((int)memoUTF8Text);					// Msg Type...	
	stream.Write_U8S_from_Unicode(strSubject);			// Subject...
	stream.Write_U8S_from_Unicode(strContents);			// Message

	ULONG uTrid = 0;

	// KEH_API
	// 10-02-09
	// ޸ ID ǽð ϶ ùٸ  Ѿ´. α     Ǿ 
	//  ޸ Ŀǵ ID MSNG_CMD_SENDMEMOEX ϰ
	// MSNG_CMD_SENDMEMO ߰ϴ ۾ Ǿ.
	// ,  ʴ  ޸ Ϲ   иϿ.
	uTrid = pDispatcher->Send_REQUEST_PACKET(MSNG_CMD_SENDMEMO, (USHORT)stream.GetDataLen(), stream.GetData(), this);

	P_GT_MEMO_DATA sData;
	sData.eType = memoUTF8Text;
	sData.strFromID = GetUserID();
	sData.strToID = strTargetUserID;
	sData.strSubject = strSubject;
	sData.strMessage = strContents;

	m_mapSendMemoMapForTrid.insert(sendmemomap_t::value_type(uTrid, sData));

	if(pTrid)
		*pTrid = uTrid;

	m_listTridForNpMsgr.push_back(uTrid);

	return true;
}

void CMessengerActor::_LoadURLPack(void)
{
	m_sURLPack.strURL_CheckNotice			= GetURL("URL_CHECK_NOTICE", "");
	m_sURLPack.strURL_RedirectRequest		= GetURL("URL_REDIRECT_REQ", "");
	m_sURLPack.strURL_Notice				= GetURL("URL_ANNOUNCE", "");
    m_sURLPack.strURL_Maintenance			= GetURL("URL_MAINTENANCE", "");
	m_sURLPack.strURL_HomePage				= GetURL("URL_HOMEPAGE", "");
	m_sURLPack.strURL_Event					= GetURL("URL_EVENT", "");
	m_sURLPack.strURL_FAQ					= GetURL("URL_FAQ_PAGE", "");
	m_sURLPack.strURL_UserGuide				= GetURL("URL_USERGUIDE", "");
	m_sURLPack.strURL_ChangePassword		= GetURL("URL_MOD_PASSPAGE", "");
	m_sURLPack.strURL_NaverChangePassword	= GetURL("URL_NAVER_MOD_PASSPAGE", "");
	m_sURLPack.strURL_FindPassword			= GetURL("URL_FIND_PASSPAGE", "");
	m_sURLPack.strURL_FindID				= GetURL("URL_FIND_IDPAGE", "");
	m_sURLPack.strURL_GameTalkRoomCreate	= GetURL("URL_MAKE_ROOM", "");
	m_sURLPack.strURL_GameTalkRoomUpdate	= GetURL("URL_MODIFY_ROOM", "");
	m_sURLPack.strURL_GameTalkRoomView		= GetURL("URL_VIEW_ROOM", "");
	m_sURLPack.strURL_ClientPatch		    = GetURL("URL_CLIENT_PATCH", "");
	m_sURLPack.strURL_DownloadMulticonPack	= GetURL("SVR_UPDATE", "OBJ_MULTICON_PAC");
	m_sURLPack.strURL_WaitRoomChattingPanel = GetURL("URL_GWR_CHAT_PAGE","");
	m_sURLPack.strURL_WaitRoomCategoryPanel = GetURL("URL_GWR_CATEGORY_PAGE","");
	m_sURLPack.strURL_WaitRoomEmoticonPanel = GetURL("URL_GWR_EMOTICON_PAGE","");
}


bool CMessengerActor::GetFAQList(GT_FAQ_DATA_LIST &sFAQList)
{
	sFAQList.nSize = m_listFAQ.size();
	sFAQList.pList = sFAQList.nSize > 0 ? &m_listFAQ[0] : NULL;
	return true;
}


bool CMessengerActor::GetURLPack(GT_URL_PACK_DATA &sPack)
{
	if(!IsValidLoginState())
	{
		memset(&sPack, 0x00, sizeof(sPack));
		return false;
	}
	
	m_sURLPack.Convert(sPack);
	return true;
}

bool CMessengerActor::GetSpecInfo(GT_API_SPEC_DATA &sSpecInfo)
{
	if(GetActorState() == masLoginFailed)
		return false;

	m_sSpecInfo.Convert(sSpecInfo);
	return true;
}


size_t CMessengerActor::GetAuthDomainCount(void)
{
	return GT_GLOBAL->GetEnvironment().vecAuthDomains.size();
}


LPCWSTR CMessengerActor::GetAuthDomainFromIndex(size_t nIndex)
{
	if(nIndex >= GT_GLOBAL->GetEnvironment().vecAuthDomains.size())
		return NULL;
	return GT_GLOBAL->GetEnvironment().vecAuthDomains[nIndex].c_str();
}


const WSTRING CMessengerActor::GetURL(LPCSTR strServer, LPCSTR strPage, LPCSTR strDefaultServer, LPCSTR strDefaultPage)
{
	WSTRING strReturnVal;

	USES_UTF8_CONVERSION;
	
	char szTemp[1024] = {0,};

	if(GetNpMsgr() != NULL)
	{
		INpMsgrConfig *pConfig = GetNpMsgr()->GetNpMsgrConfig();
		GT_ASSERT(pConfig);

		if ( pConfig->GetServerConfig("SERVICE_URL", strServer, szTemp, 1024))
		{
			strReturnVal = U82W(szTemp);

			if (pConfig->GetServerConfig("SERVICE_URL", strPage, szTemp, 1024))
				strReturnVal += U82W(szTemp);
			else if(strDefaultPage)
				strReturnVal += U82W(strDefaultPage);
		}
	}

	if (strReturnVal.length() < 1 && strDefaultServer && strDefaultPage)
	{
		strReturnVal = U82W(strDefaultServer);
		strReturnVal += U82W(strDefaultPage);
	}
	
	strReturnVal = _DnsStateCheck(strReturnVal);

	if(strReturnVal.find(_T("https:"), 0) == 0)
	{
		return strReturnVal;
	}
	if (strReturnVal.find(_T("http:"), 0) > 0) 
	{
		strReturnVal.insert(0, _T("http://"));
		return strReturnVal;
	}	
	else	
		return strReturnVal;	
}


WSTRING CMessengerActor::_DnsStateCheck(WSTRING strURL)
{
	INpMsgr *pMsgr = GetNpMsgr();
	if(pMsgr == NULL)
		return strURL;

	if( pMsgr->GetDnsFailReport() != 0 )
	{
		stringmap_t::iterator it = GT_GLOBAL->GetEnvironment().mapWASAddress.begin();
		for (; it != GT_GLOBAL->GetEnvironment().mapWASAddress.end(); ++it)
		{
			if(StringUtil::StringReplaceAll(strURL, it->first, it->second) > 0)
				break;
		}
	}

	return strURL;
}






//------------------------------------------------------------------------------------------------
//
// _INpMsgrEvents 
//
//------------------------------------------------------------------------------------------------


void CALLBACK CMessengerActor::NpMsgr_OnReloginEnd(INpMsgr * pNpMsgr, int nResultCode, int nErrorCode)
{
	// Re-α 
	if( nResultCode == RC_OK )
	{
        m_bReloginWorking = true;
        
		m_bReloginOKFlag = true;
		
		RequestMyPage();
	}
	else 
	{
		m_bReloginOKFlag = false;

		SetActorState(masReloginFailed);
	}
}

void CALLBACK CMessengerActor::NpMsgr_SetLoginWorking(INpMsgr * pNpMsgr, bool bLogining)
{
	this->m_bLoginWorking = bLogining;
}

void CALLBACK CMessengerActor::NpMsgr_OnLoginEnd(INpMsgr * pNpMsgr, int nResultCode, int nErrorCode)
{
#if defined(WIN32)		
	USES_CONVERSION; // for A2CT
#endif	
	m_bReloginOKFlag = false;

//	GT_STOP_WATCH(g_nInternalPresetStopWatch4, "GLS LOGIN END");
	
	// α 
	if( nResultCode == RC_OK )
	{	
		m_bIsEverLoginOKFlag = true;
		
//		m_log.Trace(_T("GLS LOGIN SUCC : USERID = %s"), GetUserID());	

		if (nErrorCode == MSNG_OK_FIRSTLOGIN)	//  α
			m_bIsFirstLogin = true;
		else
			m_bIsFirstLogin = false;
		
		// URL ٷ̸  Ѵ.
		_LoadURLPack();
		
//		GT_STOP_WATCH(g_nInternalPresetStopWatch3, "TOTAL WAS LOGIN START");
		
#ifdef __KEH_MOBILE_NO_WAS_CALL__
		_OnLoginEnd();
#else	

		m_sMyUserData.sMyPage.strUserID = pNpMsgr->GetNpMsgrUser()->Id();
		m_sMyUserData.strUserID = pNpMsgr->GetNpMsgrUser()->Id();
		RequestMyPage();
#endif		
	}
	// α 
	else
	{
		USES_UTF8_CONVERSION;
		
		RequestLogout( lortByMsgrLoginFail );

//        DLOG("LOGIN PARSER ERRORSTRING : %s", pNpMsgr->GetLastErrorMsg());

        nfc::CUTF8Buffer buf1;
        nfc::CUTF8Buffer buf2;
        nfc::CUTF8Buffer buf3;

		CHangameLoginResultParser parse;
		parse.SetLoginResult(lirtServerLoginFail, 
                             nResultCode, 
							 nErrorCode, 
							 A2CT(pNpMsgr->GetLastErrorMsg()),
							 A2CT(pNpMsgr->GetResultCodeMsg(nResultCode)),
							 A2CT(pNpMsgr->GetServerDefinedCodeMsg(nErrorCode)));
		
		parse.DoParse();
		parse.GetResult(m_sLoginErrorData);

		m_sLoginErrorData.nLaunchingCheckResult = pNpMsgr->GetNpMsgrUser()->LaunchingCheckResult();
		m_sLoginErrorData.strLaunchingResultURL = pNpMsgr->GetNpMsgrUser()->LaunchingResultURL();
		
//		m_log.Trace(_T("GLS LOGIN FAIL : USERID = %s, RES = %d(0x%x,0x%x)"), GetUserID(), m_sLoginErrorData.eErrorCode, nResultCode, nErrorCode);
        //NTALK_LOG->Debug(L"[LOGIN] Login Failed : %d/%d", nResultCode, nErrorCode);   // KEH_LHC_ELOG
//		GTLog::RemotePrintLogW(L"Login Fail - Login Server: %ls", GetUserID());

		SetActorState(masLoginFailed);
	}
}


void CALLBACK CMessengerActor::NpMsgr_OnDisconnected(INpMsgr * pNpMsgr, int nType)
{
	OutputDebugString(_T("\r\n##### CMessengerActor::NpMsgr_OnDisconnected #####"));
	if(nType == 0)	// ping check
	{
		SetActorState(masDisconnected);
	}
	else if(nType == 1) // socket error
	{
		SetActorState(masDisconnected);
	}
	else if(nType == 2) // Not Available Network
	{
		m_eLogoutType = lortByNotAvailableNetwork;
		SetActorState(masNetNotAvailable);
	}
}

void CALLBACK CMessengerActor::NpMsgr_OnKilled(INpMsgr * pNpMsgr, int nType)
{
	OutputDebugString(_T("\r\n##### CMessengerActor::NpMsgr_OnKilled #####"));
	if (nType == 0)
		RequestLogout(lortByDuplicate);
	else
	{
		//	RequestLogout(lortByDisconnect);

		m_bLoginWorking = false;
		m_sMyUserData.eLoginState = masInit;
		m_sMyUserData.eUserStatusType = ustOFFLINE;

		CLoginStateNotifyCommand cCommand(this, masReloginFailed);
			cCommand.Execute();
	}
}


void CALLBACK CMessengerActor::NpMsgr_OnResult_SendMessage(INpMsgr * pNpMsgr, int nErrorCode)
{

}


void CALLBACK CMessengerActor::NpMsgr_OnResult_BuddyInfo_ActiveXChat(INpMsgr * pNpMsgr, std::map<WSTRING, BYTE> &mapBuddyInfo)
{
	CGetBuddyStatusNotifyCommand *pCommand = CGetBuddyStatusNotifyCommand::Create(this, mapBuddyInfo);
	if(pCommand)
		pCommand->ExecuteAsync();
}


void CALLBACK CMessengerActor::NpMsgr_OnResult_ChangeOnlineStatus(INpMsgr * pNpMsgr, int nErrorCode, E_MSGR_ONLINE_STATUS status)
{
	_ConvertMyStatus(status);

	if (nErrorCode == 0)
	{
		CUserStatusNotifyCommand *pCommand = CUserStatusNotifyCommand::Create(this, NOTIFY_FLAG_PRESENCE, status, 0, 0);
		if(pCommand)
			pCommand->ExecuteAsync();
	}
}

void CALLBACK CMessengerActor::NpMsgr_OnResult_ChangeNick(INpMsgr * pNpMsgr, int nErrorCode, LPCWSTR pszNick)
{
	if (nErrorCode == 0)
	{
		m_sMyUserData.sMyPage.strTalkName = pszNick;
		CUserTalkNameNotifyCommand *pCommand = CUserTalkNameNotifyCommand::Create(this, pszNick);
		if(pCommand)
			pCommand->ExecuteAsync();
	}
}


void CALLBACK CMessengerActor::NpMsgr_OnReceive_SystemNotify(char *pSystemNotice)
{
	CSystemNotifyCommand *pCommand = CSystemNotifyCommand::Create(this, pSystemNotice);
	if(pCommand)
		pCommand->ExecuteAsync();
}

void CMessengerActor::_OnRecvedInviteMsg(LPCWSTR wszUserID, ULONG ulTime, BYTE nMemoType, LPCWSTR wszSubject, void * pMsg, ULONG ulMsgSize)
{
	USES_UTF8_CONVERSION;

	P_GT_ROOM_INVITE_NOTIFY_DATA sInvite;	
	WSTRING strData = U82W((LPCSTR)pMsg);
	std::vector<WSTRING> strList;
	StringUtil::StringTokenizer<WSTRING>(strData, _T("|"), strList);

	sInvite.eRoomType = rtMMC;

	if(strList.size() > 0)	sInvite.strInviteID = strList[0];
	else return; //  ߻

	if(strList.size() > 1)	sInvite.strInviteTalkName = strList[1];
	else return; //  ߻

	if(strList.size() > 2)	sInvite.strRoomTitle = strList[2];
	else return; //  ߻

	if(strList.size() > 3)	sInvite.nRoomID = _wtoi((WCHAR*)strList[3].c_str());
	else return; //  ߻

	if(strList.size() > 4)	sInvite.strRoomPwd = strList[4];
	else return; //  ߻
	
	if(strList.size() > 5) sInvite.strRoomMasterID = strList[5];
	else return; //  ߻

	if(strList.size() > 6) sInvite.bMobileUsageFlag = _wtoi((WCHAR*)strList[6].c_str()) == 1 ? true : false;;
	//else return; // NO ERROR

/*
	if(strList.size() > 0)	sInvite.strInviteID = strList[0];
	else return; //  ߻

	if(strList.size() > 1)	sInvite.strInviteTalkName = strList[1];
	else return; //  ߻

	if(strList.size() > 2)	sInvite.nRoomID = _wtoi((WCHAR*)strList[2].c_str());
	else return; //  ߻

	if(strList.size() > 3)	sInvite.strChatSrvAddress = strList[3];
	else return; //  ߻
	
	if(strList.size() > 4) sInvite.nChatSrvPort = _wtoi((WCHAR*)strList[4].c_str());
	else return; //  ߻	
*/
	CMMCInviteNotifyCommand *pCommand = CMMCInviteNotifyCommand::Create(this, sInvite);
	if(pCommand)
		pCommand->ExecuteAsync();
}

void CALLBACK CMessengerActor::NpMsgr_OnReceive_NoteNotify(ULONGLONG lNoteId, LPCWSTR strFromID, LPCWSTR strFromName, ULONG nUnreadNoteCnt)
{
	USES_UTF8_CONVERSION;

	OutputDebugString(_T("\r\n##### NpMsgr_OnReceive_NoteNotify #####\r\n"));

	CNoteNotifyCommand *pCommand = CNoteNotifyCommand::Create(this, lNoteId, strFromID, strFromName, nUnreadNoteCnt);
	if(pCommand)
		pCommand->ExecuteAsync();
}

void CALLBACK CMessengerActor::NpMsgr_OnReceive_NoteUnreadCntNotify(ULONG lUnreadCnt)
{
	USES_UTF8_CONVERSION;

	OutputDebugString(_T("\r\n##### NpMsgr_OnReceive_NoteUnreadCntNotify #####\r\n"));

	CNoteNotifyUnreadCntCommand *pCommand = CNoteNotifyUnreadCntCommand::Create(this, lUnreadCnt);
	if(pCommand)
		pCommand->ExecuteAsync();
}

void CALLBACK CMessengerActor::NpMsgr_OnReceive_MemoNotify(LPCWSTR wszUserID, 
                                                           ULONG ulTime, 
                                                           BYTE nMemoEncodingType, 
                                                           LPCWSTR wszSubject, 
                                                           void * pMsg, 
                                                           ULONG ulMsgSize,
														   int nMemoID)
{
	USES_UTF8_CONVERSION;

	P_GT_MEMO_DATA sMemo;

	OutputDebugString(_T("\r\n##### NpMsgr_OnReceive_MemoNotify #####\r\n"));

	// KEH_API
	// 10-02-09 
	// ޸ ID ǽð ϶ ùٸ  Ѿ´. α     Ǿ
	//  ޸ Ŀǵ ID MSNG_CMD_SENDMEMOEX ϰ
	// MSNG_CMD_SENDMEMO ߰ϴ ۾ Ǿ.
	// ,  ʴ  ޸ Ϲ   иϿ.
	sMemo.nMemoID = nMemoID;
	sMemo.strFromID = wszUserID;
	sMemo.strToID = GetUserID();

	//   ̱   ð  EMPTY!!
	memset(&sMemo.dtReadDate, 0x0, sizeof(sMemo.dtReadDate));

	GTCommonAPI::TimeToSystemTime(ulTime, &sMemo.dtSendDate);

	sMemo.nReadDate = 0;
	sMemo.nSendDate = ulTime;

	sMemo.strSubject = wszSubject;

	switch(nMemoEncodingType)
	{
	case memoUTF8Text:
		{
			sMemo.eType = memoUTF8Text;
			//sMemo.strMessage = U82W((LPCSTR)pMsg);
			sMemo.strMessage = Conversion::Utf8ToWide((char*)pMsg);
		}
		break;
	case memoUnicode:
		{
			sMemo.eType = memoUnicode;
			sMemo.strMessage = (WCHAR*)pMsg;
			break;
		}
	//  [¶/ ʴ]   ޸   Ǿ!
	case memoInvte: // ȭʴ˸...2012.12.13 chk
		OutputDebugString(_T("\r\n##### _OnRecvedInviteMsg #####\r\n"));
		_OnRecvedInviteMsg(wszUserID, ulTime, nMemoEncodingType, wszSubject, pMsg, ulMsgSize);
		return;

	default:
		return;
	}

	CMemoNotifyCommand *pCommand = CMemoNotifyCommand::Create(this, sMemo);
	if(pCommand)
		pCommand->ExecuteAsync();
}

void CALLBACK CMessengerActor::NpMsgr_NeedUpdateLoginTicket(void)
{
	// 2011-04-06
	// BY SILOS AUTH
	// Always need new ticket after use..
	
	GetNewMessengerTicket();
}

void CALLBACK CMessengerActor::NpMsgr_CheckClientNetwork(void)
{
	trid_t trid = GT_GLOBAL->GetTransactionID(NULL);
	bool bRet = m_pWASActor->RequestCheckClientNetwork(&trid);

	if(bRet)
		_AddMyTransaction(trid);
}



//------------------------------------------------------------------------------------------------
//
// _INpMsgrBuddyEvents 
//
//------------------------------------------------------------------------------------------------

void CALLBACK CMessengerActor::NpMsgrBuddy_OnSync_BuddyAdd(int nError, LPCWSTR wszErrMsg, std::map<LPCWSTR, IBuddy *> &mapAddedBuddy, IGroup * pParentGroup, int nGroupID, int nBuddyID, int nCallerTrId)
{
	ATLTRACE(TEXT("CMessengerActor::NpMsgrBuddy_OnSync_BuddyAdd\n"));

	USHORT usResultCode = LOWORD(nError);
	USHORT usResponseCode = HIWORD(nError);

	P_GT_BUDDY_RESULT_DATA sResult;
	sResult.Clear();
	sResult.trid = nCallerTrId;
	sResult.eAction = buddyAction_Add;
	sResult.eWasError = wasError_NotRequest;
	sResult.nRawErrorCode = usResponseCode;
	sResult.strRawErrorMsg = wszErrMsg;

	// ģ ߰ !
	if( usResultCode == RC_OK )
	{ 
		sResult.eError = buddyError_None;

		// ̹ ģ  !
		// buddylist  AddressBook  !
		if (usResponseCode == MSNG_OK_ALREADYBUDDY)
		{
			// ̹    !
			// ̹  ⼭ CGetBuddyProfileCmd  ȣ..   ص!
		}


			
		const wchar_t* sperator = L"|";
		std::wstring listUserID;
		for( std::map<LPCWSTR, IBuddy *>::iterator itr = mapAddedBuddy.begin(); itr != mapAddedBuddy.end(); itr++ )
		{
			LPCWSTR wszId = itr->first;
			IBuddy *pBuddy = itr->second;

			if (listUserID.empty() == false)
				listUserID.append(sperator);
			listUserID.append(wszId);

			GT_ASSERT(pBuddy);

			//  ģ ʿ ߰Ѵ
			CBuddyUser *pBuddyUser = _CreateBuddyInfo(pBuddy);
			if (NULL == pBuddyUser)
			{
				continue;
			}

			P_GT_BUDDY_DATA data;
			data.Clear();
			data.SetGroupID(nGroupID);
			data.SetID(rand());
			data.SetUserID(wszId);
			                	        
			// ׷ ִ üũ
			CBuddyGroup *pBuddyGroup = _GetBuddyGroupInfo(data.GetGroupID());
			if(pBuddyGroup == NULL)
			{
				// ׷  Ʈ ׷쿡 ߰!
				data.SetGroupID(GetDefaultGroupID());

				pBuddyGroup = _GetBuddyGroupInfo(data.GetGroupID());
				GT_ASSERT(pBuddyGroup);
			}

			const NE_MEMBER_DATA* pMemberData = GetEmployeeInfo(data.GetUserID().c_str());
			data.SetName(pMemberData->strName);
			data.SetTalkName(pMemberData->strNickName);

			pBuddyUser->SetData(data);
			pBuddyUser->CollectData();
		
			// ģ  
			sResult.sBuddyInfo = pBuddyUser->GetData();
			m_vecBuddy.push_back(pBuddyUser);
			pBuddyGroup->AddBuddyUser(pBuddyUser);

			_SetBuddyInPersistMap(pBuddyUser);


			sResult.eWasError = wasError_None;
			sResult.eError = buddyError_None;
			sResult.sBuddyInfo.SetUserID(wszId);
			sResult.sBuddyInfo.SetGroupID(nGroupID);

			CBuddyActionNotifyCommand *pCommand = CBuddyActionNotifyCommand::Create(this, sResult);
			if(pCommand)
				pCommand->ExecuteAsync();
		}
	}
	else
	{
		// ģ߰  !

		switch(usResponseCode)
		{
		case MSNG_ERR_MAX_LIMIT1:	
			sResult.eError = buddyError_Max; 
			break;
		case MSNG_ERR_CANNOT_ADD_YOURSELF:
			sResult.eError = buddyError_AddYourSelf; 
			break;
		case MSNG_ERR_ALREADY_REGISTERRED:
			sResult.eError = buddyError_AlreadyAdded; 
			break;
		case MSNG_ERR_BLOCKED_ID:
			sResult.eError = buddyError_BlockedId; 
			break;
		case MSNG_ERR_UNREGISTERED_MSNG_BID:
			sResult.eError = buddyError_NotFound;
			break;
		default:
			sResult.eError = buddyError_Etc; 
			break;
		}

		// ģ ߰ ж    .
		// ̵̶ ä.
		sResult.sBuddyInfo.SetID(-1);
		sResult.sBuddyInfo.SetUserID(_T(""));

		CBuddyActionNotifyCommand *pCommand = CBuddyActionNotifyCommand::Create(this, sResult);
		if(pCommand)
			pCommand->ExecuteAsync();
	}
}

void CALLBACK CMessengerActor::NpMsgrBuddy_OnSync_BuddyRemove(int nError, bool bLast, LPCWSTR wszId, int nGroupId, bool bDelGroup, IBuddy * pBuddy, int nCallerTrId)
{
	USHORT usResultCode = LOWORD(nError);
	USHORT usResponseCode = HIWORD(nError);

	P_GT_BUDDY_RESULT_DATA sResult;
	sResult.Clear();
	sResult.trid = nCallerTrId;
	sResult.eAction = buddyAction_Delete;
	sResult.eWasError = wasError_NotRequest;
	if(usResultCode == RC_OK)
		sResult.eError = buddyError_None;
	else
		sResult.eError = buddyError_Etc;	//   ڵ ! ظϸ ϱ ..  ڵ尡 .

	sResult.nRawErrorCode = usResponseCode;
	sResult.strRawErrorMsg = _T("");

	OutputDebugString(_T("\r\n@##### "));
	OutputDebugString(wszId);
	OutputDebugString(_T("#####\r\n"));	

	CBuddyUser *pBuddyUser = _GetBuddyInfo(wszId, nGroupId);
	if(pBuddyUser)
	{
		// ģ  
		sResult.sBuddyInfo = pBuddyUser->GetData();
	}
	else
	{
		// ̵̶ 
		sResult.sBuddyInfo.SetUserID(wszId);
	}

	//  ʿ 
	//_EraseBuddyInfo(pBuddy);
	_EraseBuddyInfo(wszId, nGroupId);
	
	CBuddyActionNotifyCommand *pCommand = CBuddyActionNotifyCommand::Create(this, sResult);
	if(pCommand)
		pCommand->ExecuteAsync();

	if( bDelGroup && bLast )
	{
		trid_t trid = GT_GLOBAL->GetTransactionID(NULL);
		bool bRet = m_pWASActor->RequestDelGroup(nGroupId, &trid);

		if(bRet)
			_AddMyTransaction(trid);
	}
}


void CALLBACK CMessengerActor::NpMsgrBuddy_OnSync_BlockBuddyAdd(int nError, LPCWSTR wszId, int nCallerTrId)
{
	int usResultCode = HIWORD((DWORD)nError);
	int usResponseCode = LOWORD((DWORD)nError);

	P_GT_BUDDY_RESULT_DATA sResult;
	sResult.Clear();
	sResult.trid = nCallerTrId;
	sResult.eAction = buddyAction_Block;
	sResult.eWasError = wasError_NotRequest;
	if(usResultCode == RC_OK)
		sResult.eError = buddyError_None;
	else
		sResult.eError = buddyError_Etc;	

	sResult.nRawErrorCode = usResponseCode;
	sResult.strRawErrorMsg = _T("");

	CBuddyUser *pBuddyUser = _GetBuddyInfo(wszId);

	// IBuddy *  ̿Ͽ ٽ  .
	if(pBuddyUser)
	{
		pBuddyUser->CollectData();

		sResult.sBuddyInfo = pBuddyUser->GetData();
	}
	else
	{
		// ̵̶ 
		sResult.sBuddyInfo.SetUserID(wszId);
	}
	
	CBuddyActionNotifyCommand *pCommand = CBuddyActionNotifyCommand::Create(this, sResult);
	if(pCommand)
		pCommand->ExecuteAsync();
}


void CALLBACK CMessengerActor::NpMsgrBuddy_OnSync_BlockBuddyRemove(int nError, LPCWSTR wszId, int nCallerTrId) 
{
	//  ۾̹Ƿ  Լ ȣع!
	NpMsgrBuddy_OnSync_BlockBuddyAdd(nError, wszId, nCallerTrId);
}
	

void CALLBACK CMessengerActor::NpMsgrBuddy_OnSync_WaitBuddyRemove(int nError, LPCWSTR wszId, int nCallerTrId) 
{ 
	CBuddyUser *pBuddyUser = _GetBuddyInfo(wszId);

	// IBuddy *  ̿Ͽ ٽ  .
	if(pBuddyUser)
	{
		bool bFirstLoginFlag = false;
		GT_BUDDY_DATA sPrevData;
		pBuddyUser->GetData(sPrevData);

        pBuddyUser->CollectData();

		int nUpdateType = buutStatus;

		if(sPrevData.GetStatus() == ustOFFLINE)
		{
			if(pBuddyUser->IsOnline())
			{
				nUpdateType = buutLogin;
			}
		}
		
		CBuddyStatusNotifyCommand *pCommand = CBuddyStatusNotifyCommand::Create(this, pBuddyUser->GetUserID(), nUpdateType);
		if(pCommand)
			pCommand->ExecuteAsync();
	}
}


void CALLBACK CMessengerActor::NpMsgrBuddy_OnMMCInvite(LPCWSTR wszId,		// ̵
													   LPCSTR pszPhoneTag,  // "gametalk:30000694?join"
													   LPCWSTR pszPassword, //  йȣ
													   LPCWSTR pszRoomTitle,//  
													   LPCWSTR pszTalkName) // ʴ  
{
	// <!NO_SPEC>
	// KEH_API
	// ̰   δ!
	// CtoC Ŷ ƴ϶ SEND_MEMO Ŷ JS     !

#ifdef __NOT_USED__
	USES_CONVERSION; // for A2CT

	P_GT_ROOM_INVITE_NOTIFY_DATA sInvite;	

	std::vector<WSTRING> strList;
	WSTRING strPhoneTag = A2CT(pszPhoneTag);

	// "gametalk:30000694?join" ̷  ±׿  30000694   ..
	// "gametalk:"  "?"    .  ͷ   ϳ  ۿ ..
	if(StringUtil::StringTokenizer<WSTRING>(strPhoneTag, _T("gametalk:"), _T("?"), strList) == false)
		return; // ..

	sInvite.eRoomType = rtMMC;
	sInvite.nRoomID = _ttoi(strList[0].c_str());
	sInvite.strInviteID = wszId;
	sInvite.strInviteTalkName = pszTalkName;
	sInvite.strRoomTitle = pszRoomTitle;
	sInvite.strRoomPwd = pszPassword;

	CMMCInviteNotifyCommand *pCommand = CMMCInviteNotifyCommand::Create(this, sInvite);
	if(pCommand)
		pCommand->ExecuteAsync();
#endif
}


void CALLBACK CMessengerActor::NpMsgrBuddy_OnNotifyMessage(LPCWSTR wszId, unsigned int nUserDefinedMsgCode, const char * pMsg, int nSize)
{
	std::string str;
	str.assign(pMsg, nSize);
	
	CBuddyUserStringNotifyCommand *pCommand = CBuddyUserStringNotifyCommand::Create(this, nUserDefinedMsgCode, wszId, str);
	if(pCommand)
	{
		pCommand->ExecuteAsync();
	}
}


void CALLBACK CMessengerActor::NpMsgrBuddy_OnMyStatusChanged(int nChangedFlag, wstring &strNickName, BYTE nOnlineStatus, BYTE nIPTStatus)
{
	if( nChangedFlag & NOTIFY_FLAG_PRESENCE || nChangedFlag & NOTIFY_FLAG_IPT )
	{
		//  IPT  
		NTIPTStatusType nPrevIPTStatus = iptstNA;
		if( nChangedFlag & NOTIFY_FLAG_IPT )
		{
			nPrevIPTStatus = m_sMyUserData.eIptStatusType;
			m_sMyUserData.eIptStatusType = (NTIPTStatusType)nIPTStatus;
		}

		// ޽  ٲ ʴ´.(Mobile Presence)

		CUserStatusNotifyCommand *pCommand = CUserStatusNotifyCommand::Create(this, nChangedFlag, nOnlineStatus, nPrevIPTStatus, nIPTStatus);
		if(pCommand)
			pCommand->ExecuteAsync();
	}

	if( nChangedFlag & NOTIFY_FLAG_NICK )
	{
		m_sMyUserData.sMyPage.strTalkName = strNickName;
		CUserTalkNameNotifyCommand *pCommand = CUserTalkNameNotifyCommand::Create(this, strNickName.c_str());
		if(pCommand)
			pCommand->ExecuteAsync();
	}
}

void CALLBACK CMessengerActor::NpMsgrBuddy_OnBuddyStatusChanged(IBuddy * pBuddy, int nBuddyChangedFlag, const char *pCustomData, int nDataSize)
{
	P_GT_BUDDY_DATA sBuddyInfo;

	std::vector<CBuddyUser *> vecBuddyInfo = _GetBuddyInfoAllGroup(pBuddy);
	if( vecBuddyInfo.empty() )
		return;

	int nUpdateType = _ConvertBuddyUserUpdateType(nBuddyChangedFlag);
    BOOL bFistBuddy = TRUE;

	for( std::vector<CBuddyUser *>::iterator itr = vecBuddyInfo.begin(); itr != vecBuddyInfo.end(); itr++ )
	{
		CBuddyUser *pUser = *itr;

		// IBuddy  αεǾִ  ؼ ȿ   ִ. <--- !!
		// CollectDataԼ  Ǿ! <- !!
		if( nUpdateType & buutTalkName )
		{
			pUser->SetTalkName(pBuddy->Nick());
			_UpdateNickName(pUser->GetUserID(), pBuddy->Nick());
		}

		// Map ִ   !
		pUser->CollectData();

        if (bFistBuddy)
        {
            bFistBuddy = FALSE;
            _SetBuddyInPersistMap(pUser);
        }

		// SAVE TO LOCAL DB - GameTalk

		// Notify to client
		CBuddyStatusNotifyCommand *pCommand = CBuddyStatusNotifyCommand::Create(this, pUser->GetUserID(), nUpdateType);
		if(pCommand)
			pCommand->ExecuteAsync();

		nUpdateType &= ~buutLogin;	//   ׷쿡     Ű 
	}
}

void CALLBACK CMessengerActor::NpMsgrBuddy_OnNotBuddyStatusChanged(LPCWSTR wszId, int nUserStatus, LPCWSTR wszNick, int nIPTStatus, int nFlag)
{
	{
		nfc::AutoLock<nfc::CMutex> autolock(&m_mutexBuddy);
		_SetBuddyInPersistMap(wszId, nUserStatus, wszNick, nIPTStatus, nFlag);
	}

	CNotBuddyUserStatusNotifyCommand *pCommand = CNotBuddyUserStatusNotifyCommand::Create(this, wszId, nUserStatus, wszNick, nIPTStatus, nFlag);
	if(pCommand)
		pCommand->ExecuteAsync();
}


void CALLBACK CMessengerActor::NpMsgrBuddy_OnNotifyAddedBuddy(LPCWSTR wszId, LPCWSTR wszMsg)
{
	// ̹  Callback ֱ  ʴ  Ʈ CBuddy  ִ.
	//  ݵ  FindBuddy ؾѴ.
	GT_ASSERT(m_pNpMsgr);
	IBuddy * pBuddy = m_pNpMsgr->GetNpMsgrBuddy()->FindBuddy( wszId, BTYPE_ALL );
	if( !pBuddy )
		return;

	if( pBuddy->IsBlockBuddy() )
		return;

	//   
	// BTYPE_FL :  ߰ 츦 ǹ.
	if( pBuddy->IsFowardBuddy() )
	{
		m_pNpMsgr->GetNpMsgrBuddy()->Sync_RemoveWaitBuddy( wszId );

		CBuddyUser *pBuddyUser = _GetBuddyInfo(pBuddy);

		//  ʿ !?? ̷ٴ°  ģ ߰ؼ    ³ϱ 
		//    ٴ ǹ̰ ȴ!
		// ̶   ³ ϴ° ´!
		if(pBuddyUser == NULL)
		{
			return;
		}

		// 2010-02-08 KEH
		//  κп  UI ̺Ʈ  .
		// ߰.
	}
	else
	{
		P_GT_BUDDY_INVITE_NOTIFY_DATA data;
		data.strBuddyID = wszId;
		data.strInviteMsg = wszMsg;
        
        bool duplicated = false;
        {
            std::vector<P_GT_BUDDY_INVITE_NOTIFY_DATA> & inviteList = m_sMyUserData.sMyPage.vecInviteList;
            std::vector<P_GT_BUDDY_INVITE_NOTIFY_DATA>::iterator it;
            for( it = inviteList.begin(); it != inviteList.end(); ++it )
            {
                if ( it->strBuddyID == wszId )
                {
                    duplicated = true;
                    break;
                }
            }
        }
        
        if ( false == duplicated )
        {
            m_sMyUserData.sMyPage.vecInviteList.push_back(data);
            m_sMyUserData.sMyPage.ConvertList();
        }

		CBuddyInviteNotifyCommand *pCommand = CBuddyInviteNotifyCommand::Create(this, data);
		if(pCommand)
			pCommand->ExecuteAsync();
	}
}


void CALLBACK CMessengerActor::NpMsgrBuddy_OnMMCForceKick(WORD wTimeout, LPCWSTR pszMsg1, LPCWSTR pszMsg2)
{
	//Admin  Forcekick   JS   .

}




//------------------------------------------------------------------------------------------------
//
// IPT
//
//------------------------------------------------------------------------------------------------

void CALLBACK CMessengerActor::NpMsgrIPT_OnNotifyCallInfo(LPCWSTR strUserID, LPCWSTR strTelNo, LPCWSTR strCID)
{
	CIPTCallInfoNotifyCommand *pCommand = CIPTCallInfoNotifyCommand::Create(this, strUserID, strTelNo, strCID);
	if(pCommand)
	{
		pCommand->ExecuteAsync();
	}

}

void CALLBACK CMessengerActor::NpMsgrIPT_OnResponsePhoneCall(BYTE result, LPCWSTR strCID)
{
	CIPTResponsePhoneCallNotifyCommand *pCommand = CIPTResponsePhoneCallNotifyCommand::Create(this, result, strCID);
	if(pCommand)
	{
		pCommand->ExecuteAsync();
	}

}

void CALLBACK CMessengerActor::NpMsgrIPT_OnResponseForwardingInfo(BYTE ret, BYTE act, LPCWSTR strTelNo)
{
	CIPTResponseForwardingInfoNotifyCommand *pCommand = CIPTResponseForwardingInfoNotifyCommand::Create(this, ret, act, strTelNo);
	if(pCommand)
	{
		pCommand->ExecuteAsync();
	}

}

void CALLBACK CMessengerActor::NpMsgrIPT_OnResponseResult(BYTE ret, uint16_t usIPTCMMD)
{
	CIPTResponseResultNotifyCommand *pCommand = CIPTResponseResultNotifyCommand::Create(this, ret, usIPTCMMD);
	if(pCommand)
	{
		pCommand->ExecuteAsync();
	}

}

void CALLBACK CMessengerActor::NpMsgrIPT_OnResponseDndInfo(BYTE ret, BYTE act)
{
	CIPTResponseDndInfoNotifyCommand *pCommand = CIPTResponseDndInfoNotifyCommand::Create(this, ret, act);
	if(pCommand)
	{
		pCommand->ExecuteAsync();
	}

}



//------------------------------------------------------------------------------------------------
//
// _INpSessionDispatcher_PacketHandler 
//
//------------------------------------------------------------------------------------------------

void CALLBACK CMessengerActor::INpSessionDispatcher_OnReceive_RESPONSE_PACKET(INpSessionDispatcher * /*pEventSource*/, const INpPacket * /*pOriginalRequestPacket*/, const INpPacket * pPacket)
{
	std::list<ULONG>::iterator it = std::find(m_listTridForNpMsgr.begin(), m_listTridForNpMsgr.end(), pPacket->M6V2()->ulTrId);

	if(it != m_listTridForNpMsgr.end())
	{
		m_listTridForNpMsgr.erase(it);
	}

	m_pNpMsgr->GetMainServer_SessionDispatcher()->Deregister_RESPONSE_PACKET_Handler( pPacket->M6V2()->ulTrId );

	// KEH_API
	//    û  óѴ.
	//  ʴ (MSNG_CMD_SENDMEMOEX) UI ̺Ʈ  ˷ ʴ´. <-    
	if( pPacket->M6V2()->usCMMD == RESPONSE(MSNG_CMD_SENDMEMO) )
	{
		short wErrorCode = -1; 
		int nMemoID;
		char readdate[256];
		nfc::CGBStream stream;
		stream.UseExternalBuffer(pPacket->BodyData(), pPacket->BodyLength());
	
		try
		{
			wErrorCode = stream.Read_U2();
			nMemoID = stream.Read_U4();
			stream.Read_SS(readdate);
		}
		catch(nfc::CGBStreamException e)
		{
			if(wErrorCode == -1)
				wErrorCode = MSNG_ERR_SYSTEM;
		}

		P_GT_MEMO_RESULT_DATA sData;
		sData.eWASErrorCode = wasError_None;

		switch(wErrorCode)
		{
		case MSNG_OK:
		{
			sData.trid = pPacket->M6V2()->ulTrId;

			sendmemomap_t::iterator it = m_mapSendMemoMapForTrid.find(pPacket->M6V2()->ulTrId);
			if(it != m_mapSendMemoMapForTrid.end())
			{
				SYSTEMTIME tmp;
				int Y, M, D, h, m, s;
				sscanf(readdate, "%04d-%02d-%02d %02d:%02d:%02d", &Y, &M, &D, &h, &m, &s);

				tmp.wYear = Y;
				tmp.wMonth = M;
				tmp.wDay = D;
				tmp.wHour = h;
				tmp.wMinute = m;
				tmp.wSecond = s;
			
				sData.nMemoID = nMemoID;
				sData.eAction = memoAction_Send;
				sData.dtDate = tmp;
                sData.nDateUTC = GTCommonAPI::SystemTimeToTime(&tmp);
				//sData.sMemo = it->second;
				//sData.sMemo.nMemoID = nMemoID;
				//sData.sMemo.dtSendDate = tmp;
				sData.eErrorCode = memoError_None;

				m_mapSendMemoMapForTrid.erase(pPacket->M6V2()->ulTrId);
			}
			else
				sData.eErrorCode = memoError_Etc;
			break;
		}
		case MSNG_ERR_INVALIDDATA:
			sData.eErrorCode = memoError_Data;
			break;
		case MSNG_ERR_TIMEOUTWAS:
			sData.eErrorCode = memoError_WAS;
			sData.eWASErrorCode = wasError_Timeout;
			break;
		case MSNG_ERR_CLOSEWAS:
			sData.eErrorCode = memoError_WAS;
			sData.eWASErrorCode = wasError_Etc;	//   Ȯ WAS ˼ . 
			break;
		case MSNG_ERR_UNREGISTERED_MSNG_BID:
			sData.eErrorCode = memoError_NotFoundTarget;
			break;
		case MSNG_ERR_MAX_LIMIT1:
			sData.eErrorCode = memoError_MaxSendBox;
			break;
		case MSNG_ERR_MAX_LIMIT2:
			sData.eErrorCode = memoError_MaxRecvBox;
			break;
		case MSNG_ERR_NOTFOUNDDATA:
			sData.eErrorCode = memoError_NotFoundMemo;
			break;
		case MSNG_ERR_REQUESTMYSELF:
			sData.eErrorCode = memoError_RequestMySelf;
			break;
		case MSNG_ERR_CLOSERS:
		case MSNG_ERR_SYSTEM:
			sData.eErrorCode = memoError_Server;
			break;
		default:
			sData.eErrorCode = memoError_Etc;
			break;
		}


		CSendMemoResultCommand *pCommand = CSendMemoResultCommand::Create(this, sData);
		if(pCommand)
			pCommand->ExecuteAsync();	
	}
	else
	{
	}
}


void CALLBACK CMessengerActor::INpSessionDispatcher_OnReceive_CToC(INpSessionDispatcher * pEventSource, USHORT usCToC_SubCMMD, const INpPacket * pPacket)
{
	switch (usCToC_SubCMMD) {
		case CToC_MOBILE_ADDRESSBOOK_UPDATED:   // From WAS Server (ref> MobileUtil.inc, sendNotifyMobileAddressBookUpdated
		{
			int nSerial = 0;
			nfc::CGBStream stream;
			stream.UseExternalBuffer(pPacket->BodyData(), pPacket->BodyLength());
			stream.Skip(2);
			nSerial = stream.Read_U4();
			
            if(m_pNpMsgr->GetNpMsgrUser()->CacheSerial_MobileAddressBook() < nSerial)
            {
                m_pNpMsgr->GetNpMsgrUser()->SetCacheSerial_MobileAddressBook(nSerial);
            }
            
			CNewInstalledMobileUnknownUserNotifyCommand *pCommand = CNewInstalledMobileUnknownUserNotifyCommand::Create(this, nSerial);
            
            
			if(pCommand)
				pCommand->ExecuteAsync();
		}
			break;
		default:
			break;
	}
}



//------------------------------------------------------------------------------------------------
//
// IGTWASActorEvent 
//
//------------------------------------------------------------------------------------------------


void CMessengerActor::_AdjustInviteList(void)
{
	std::vector<P_GT_BUDDY_INVITE_NOTIFY_DATA> vecInviteListNew;

	for(size_t i = 0; i < m_sMyUserData.sMyPage.vecInviteList.size(); i++)
	{
		P_GT_BUDDY_INVITE_NOTIFY_DATA sInvite = m_sMyUserData.sMyPage.vecInviteList[i];

		IBuddy *pBuddy = m_pNpMsgr->GetNpMsgrBuddy()->FindBuddy(sInvite.strBuddyID.c_str(), BTYPE_ALL);

		if(pBuddy == NULL)
		{
			//  
			//  invited list  ־Ƿ
			//  ģ߰ Ѱ 
			vecInviteListNew.push_back(sInvite);
		}
		else
		{
			if( pBuddy->BuddyType() & BTYPE_BL )
			{
				// Nothing to do..
				//  ģ      ̴.
			}
			else if( pBuddy->BuddyType() & BTYPE_FL )
			{
				//   ģ߸   ³ !  α׾ƿ̿ 
				m_pNpMsgr->GetNpMsgrBuddy()->Sync_RemoveWaitBuddy( pBuddy->Id() );

				if(GetBuddyInfo(pBuddy->Id()))
				{
					// ̹ ּҷϿ ..?
					// .
				}
				else
				{
					vecInviteListNew.push_back(sInvite);
				}
			}
			else if( pBuddy->BuddyType() & BTYPE_WL )
			{
				//   ߰  =>  Ϲ 
				vecInviteListNew.push_back(sInvite);
			}
		}
	}

	// WAS ޾ƿ MyPage  Invited list  .. 
	// 踮Ʈ WL   ϴ ģ  Ұΰ??
	// ̷   ģ ߰ 迡 ģ߰ ǰ, 
	// WAS û   ߻
	IBuddyEnum *pBuddyEnum = m_pNpMsgr->GetNpMsgrBuddy()->GetAllBuddys( BTYPE_WL );
	if( pBuddyEnum )
	{
		for( int i=0 ; i < pBuddyEnum->Getlength() ; i++ )
		{
			pBuddyEnum->Getitem(i)->Id();
		}

		pBuddyEnum->Delete();
	}

	m_sMyUserData.sMyPage.vecInviteList = vecInviteListNew;
	m_sMyUserData.sMyPage.ConvertList();
}



bool CMessengerActor::OnGTWASActor_ResponseMyPage(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const GT_MYPAGE_DATA &data, const GT_API_SPEC_DATA &spec, const GT_FAQ_DATA_LIST &listFAQ, NE_LEVEL_DATA_LIST &list, int nCategoryCacheSerial)
{
	if (_IsMyTransaction(trid) == false)
		return true;

	//  !
	if (eErrorCode != wasError_None)
	{
		_LoginFail(pActor, trid, lirtWAS_MyPageFail, eErrorCode);
		return true;
	}

//	GT_STOP_WATCH(g_nInternalPresetStopWatch1, "MYPAGE OK");

	// MyPage   
	m_sMyUserData.sMyPage.Load(data);
	m_sLevelList = list;
	
	////////////////////////////////////////////////////////
	// α ..
	if (GetActorState() == masReceivingMyPage)
	{
		RequestBuddyGroupList();
		return false;
	}
	////////////////////////////////////////////////////////
	
	return true;
}


bool CMessengerActor::OnGTWASActor_ResponseBuddyGroupList(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, int nDefaultGroupID, const GT_BUDDY_GROUP_DATA_LIST &list)
{
	if(_IsMyTransaction(trid) == false)
		return true;

	if(eErrorCode == wasError_None)
    {
        m_nDefaultGroupID = nDefaultGroupID;
        
        _ReloadBuddyGroupList(list);
    }

//	GT_STOP_WATCH(g_nInternalPresetStopWatch1, "GROUPLIST OK");


	////////////////////////////////////////////////////////
	// α ̶..
	if(GetActorState() == masReceivingBuddyGroup)
	{
		//  !
		if(eErrorCode != wasError_None)
		{
			_LoginFail(pActor, trid, lirtWAS_BuddyGroupFail, eErrorCode);
			return true;
		}
		else
		{
			RequestBuddyList(false);
		}

		return false;
	}
	////////////////////////////////////////////////////////

	return true;
}


bool CMessengerActor::OnGTWASActor_ResponseBuddyList(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, bool bAllRecvedList, const GT_BUDDY_DATA_LIST &list)
{
	if(_IsMyTransaction(trid) == false)
		return true;


    if(eErrorCode == wasError_None)
    {
        bool bError = false;
        if(bAllRecvedList)
        {
            if(!_ReloadBuddyList(list))
            {
                bError = true;
            }
        }
        else
        {
            if(false == _UpdateBuddyList(list)) // In this, called IGTLocalDBProxy::SaveBuddyAddressBookData
            {
                bError = true;
            }
            else
            {
                _CheckValidBuddyList();
            }
        }
    }

	// α ̶..
	if(GetActorState() == masReceivingBuddyInfo)
	{
		//  !
		if(eErrorCode != wasError_None)
		{
			_LoginFail(pActor, trid, lirtWAS_BuddyGroupFail, eErrorCode);
			return true;
		}
		else
		{
			RequestEmployeeInfoList();
		}

		return false;
	}
	////////////////////////////////////////////////////////
	else // α ߿   ̺Ʈ  ʿ䰡 !
	{
		CListBuddyNotifyCommand *pCommand = CListBuddyNotifyCommand::Create(this);
		if(pCommand)
			pCommand->ExecuteAsync();	
	}

	return false;	// ̻   !
}

bool CMessengerActor::OnGTWASActor_ResponseUpdateBuddy(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const vector< pair<wstring, int> > &vecBuddy, int nNewGrpID)
{
	if(_IsMyTransaction(trid) == false)
		return true;

	vector< pair<wstring, int> >::const_iterator itr = vecBuddy.begin();
	for(; itr != vecBuddy.end(); itr++)
	{
		P_GT_BUDDY_RESULT_DATA sResult;
		sResult.Clear();
		sResult.trid = trid;
		sResult.eAction = buddyAction_Update;

		CBuddyUser *pBuddyUser = _GetBuddyInfo(itr->first.c_str(), itr->second);
		if(pBuddyUser)
		{
			if(eErrorCode == wasError_None)	// 
			{
				sResult.nFromGroupID = pBuddyUser->GetGroupID();

				//  Ϳ   !
				_MoveGroupBuddyInfo(pBuddyUser, pBuddyUser->GetGroupID(), nNewGrpID);

				sResult.eError = buddyError_None;
			}
			else
			{
				sResult.eError = buddyError_Etc;
			}

			sResult.sBuddyInfo = pBuddyUser->GetData();
		}
		else
		{
			ASSERT(FALSE);
		}

		sResult.eWasError = eErrorCode;
		sResult.nRawErrorCode = 0;
		sResult.strRawErrorMsg = _T("");

		CBuddyActionNotifyCommand *pCommand = CBuddyActionNotifyCommand::Create(this, sResult);
		if(pCommand)
			pCommand->ExecuteAsync();
	}

	return true;
}


bool CMessengerActor::OnGTWASActor_ResponseSearchBuddy(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, bool bSuccess, GT_BUDDY_SEARCH_RESULT_DATA &data)
{
	if(_IsMyTransaction(trid) == false)
		return true;

	P_GT_BUDDY_RESULT_DATA sResult;
	sResult.Clear();
	sResult.trid = trid;
	sResult.eAction = buddyAction_Search;

	if(bSuccess == true)	// 
		sResult.eError = buddyError_None;
	else
		sResult.eError = buddyError_NotFound;

	sResult.eWasError = eErrorCode;
	sResult.nRawErrorCode = 0;
	sResult.strRawErrorMsg = _T("");
	sResult.sSearchResult.Load(data);

	// ̵̶  ־
	sResult.sBuddyInfo.SetUserID(data.strUserID);

	CBuddyActionNotifyCommand *pCommand = CBuddyActionNotifyCommand::Create(this, sResult);
	if(pCommand)
		pCommand->ExecuteAsync();

	return true;
}


bool CMessengerActor::OnGTWASActor_ResponseAddGroup(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const GT_BUDDY_GROUP_DATA &data, GTBuddyAddGroupType addGroupType)
{
	OutputDebugString( _T("CMessengerActor::OnGTWASActor_ResponseAddGroup ===================================\n") );

	if(_IsMyTransaction(trid) == false)
		return true;

	P_GT_BUDDY_GROUP_RESULT_DATA sResult;
	sResult.trid = trid;
	sResult.eAction = buddyGroupAction_Add;

	CBuddyGroup *pBuddyGroup = NULL;
	switch(eErrorCode)
	{
	case wasError_None: // 
		{
			sResult.eError = buddyGroupError_None;

			// ̹ ִ üũ
			pBuddyGroup = _GetBuddyGroupInfo(data.strName);
			if(pBuddyGroup)
			{
				// ܻȲ.. ⺻׷  쿡  ⺻׷ Addϴ ġ Ѵ.
				// ⺻ ׷ ߰ Ư Ȳ
				if(GT_GLOBAL->GetEnvironment().strDefaultBuddyGroupName == data.strName)
				{
					//    ޸ !  ֽ ⺻ ׷ ̴ϱ!!
					pBuddyGroup->SetData(data);
				}
				else
				{
					sResult.eError = buddyGroupError_AlreadyExist;
				}
			}
			else
			{
				// ׷ʿ ߰!
				pBuddyGroup = _CreateBuddyGroupInfo();
				if (NULL != pBuddyGroup)
				{
					pBuddyGroup->SetData(data);
					m_vecBuddyGroup.push_back(pBuddyGroup);
				}
			}
		}
		break;
	case wasError_Max:
		sResult.eError = buddyGroupError_Max;
		break;
	default:
		sResult.eError = buddyGroupError_Etc;
	}

	sResult.eWasError = eErrorCode;
	sResult.nGroupID = data.nID;

	CBuddyGroupActionNotifyCommand *pCommand = CBuddyGroupActionNotifyCommand::Create(this, sResult, addGroupType);
	if(pCommand)
		pCommand->ExecuteAsync();

	if( buddyGroupAction_Import == addGroupType )	// ã IMPORT
		RequestAddBuddy(sResult.nGroupID, m_vecImportBuddy.begin()->vecBuddyID, _T(""), abtImportBuddy);

	return true;
}


bool CMessengerActor::OnGTWASActor_ResponseDelGroup(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, int nGroupID)
{
	if(_IsMyTransaction(trid) == false)
		return true;

	P_GT_BUDDY_GROUP_RESULT_DATA sResult;
	sResult.trid = trid;
	sResult.eAction = buddyGroupAction_Delete;

	if(eErrorCode == wasError_None)	// 
		sResult.eError = buddyGroupError_None;
	else if(eErrorCode == wasError_NotEmpty)
		sResult.eError = buddyGroupError_NotEmpty;
	else
		sResult.eError = buddyGroupError_Etc;

	sResult.eWasError = eErrorCode;

	CBuddyGroup *pBuddyGroup = _GetBuddyGroupInfo(nGroupID);
	if(pBuddyGroup)
	{
		sResult.nGroupID = pBuddyGroup->GetID();
	}
	else
	{
		sResult.nGroupID = nGroupID; //  ̶ ä!
	}
	
	if(sResult.eError == buddyGroupError_None)
	{
		//  ׷ʿ 
		_EraseBuddyGroupInfo(nGroupID);
	}

	CBuddyGroupActionNotifyCommand *pCommand = CBuddyGroupActionNotifyCommand::Create(this, sResult, buddyGroupAction_NotAdd);
	if(pCommand)
		pCommand->ExecuteAsync();
	
	return true;
}


bool CMessengerActor::OnGTWASActor_ResponseUpdateGroup(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, int nGroupID, GT_BUDDY_GROUP_UPDATABLE_DATA &data)
{
	if(_IsMyTransaction(trid) == false)
		return true;

	P_GT_BUDDY_GROUP_RESULT_DATA sResult;
	sResult.trid = trid;
	sResult.eAction = buddyGroupAction_Update;

	if(eErrorCode == wasError_None)	// 
		sResult.eError = buddyGroupError_None;
	else if(eErrorCode == wasError_DuplicateGroupName) //׷ ߺ
		sResult.eError = buddyGroupError_AlreadyExist;
	else
		sResult.eError = buddyGroupError_Etc;

	sResult.eWasError = eErrorCode;

	// ׷ʿ ؾ!
	CBuddyGroup *pBuddyGroup = _GetBuddyGroupInfo(nGroupID);
	if(pBuddyGroup)
	{
		pBuddyGroup->LoadData(data);
		sResult.nGroupID = pBuddyGroup->GetID();
		
		GT_BUDDY_GROUP_DATA data;
		pBuddyGroup->GetData(data);
	}
	else
	{
		sResult.nGroupID = -1;
		sResult.eError = buddyGroupError_NotFound;
	}
	
	CBuddyGroupActionNotifyCommand *pCommand = CBuddyGroupActionNotifyCommand::Create(this, sResult, buddyGroupAction_NotAdd);
	if(pCommand)
		pCommand->ExecuteAsync();

	return true;
}


bool CMessengerActor::OnGTWASActor_ResponseUpdateGroupSortOrder(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, vector<GT_BUDDY_GROUP_DATA> &vecBuddyGroupData)
{
	if(_IsMyTransaction(trid) == false)
		return true;

	// ׷ʿ ؾ!
	vector<GT_BUDDY_GROUP_DATA>::iterator itr = vecBuddyGroupData.begin();
	for(; itr != vecBuddyGroupData.end(); itr++)
	{
		CBuddyGroup *pBuddyGroup = _GetBuddyGroupInfo(itr->nID);
		if( pBuddyGroup )
		{
			pBuddyGroup->SetSortID(itr->nSortOrder);
			//; // TODO: ׷  
		}
	}

	CBuddyGroupSortOrderNotifyCommand *pCommand = CBuddyGroupSortOrderNotifyCommand::Create(this, trid, vecBuddyGroupData);
	if(pCommand)
		pCommand->ExecuteAsync();

	return true;
}

bool CMessengerActor::OnGTWASActor_ResponseGetEmployeeInfo( IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_MEMBER_DATA_LIST &list, NTRequestEmpInfoType reqEmpInfoType, int nGroupID )
{
	OutputDebugString( _T("CMessengerActor::OnGTWASActor_ResponseGetEmployeeInfo ===================================\n") );
	if (reitGetPhotoURL == reqEmpInfoType)
	{
		//Add employee info
		//So that, user can get photoURL by calling GetEmployeeInfo,
		//but not RequestEmployeeInfo
		//Especially for users without photos, 
		//they can find out does they have photos by calling GetEmployeeInfo
		if (wasError_None == eErrorCode)
		{
			_AddEmployeeInfo(list);
			//user begin chat from organization chart, will check and add into m_mapBuddyPersist
			for(size_t i = 0; i < list.nSize; i++)
			{
				_SetBuddyInPersistMap(list.pList[i].strUserId.c_str(), list.pList[i]);
			}
		}

		vector<P_GT_USER_IMAGE_RESULT_DATA> sResult;
		for (int i = 0; i < (int)list.nSize; i++)
		{
			P_GT_USER_IMAGE_RESULT_DATA  result;
			result.strUserId = list.pList[i].strUserId.c_str();
			result.strUserImageURL = list.pList[i].strPhotoURL.c_str();
			sResult.push_back(result);
		}	

		CUserImageNotifyCommand *pCommand = CUserImageNotifyCommand::Create(this, sResult);
		if(pCommand)
			pCommand->ExecuteAsync();

		return true;
	}
	if ( reitSingleTrans == reqEmpInfoType
		 || (reitLogin != reqEmpInfoType && _IsMyTransaction(trid, false))
		)
	{
		if (wasError_None == eErrorCode)
		{
			_AddEmployeeInfo(list);
			//user begin chat from organization chart, will check and add into m_mapBuddyPersist
			for(size_t i = 0; i < list.nSize; i++)
			{
				_SetBuddyInPersistMap(list.pList[i].strUserId.c_str(), list.pList[i]);
			}
		}
	}

	if(_IsMyTransaction(trid) == false)
		return true;

	if(eErrorCode == wasError_None)	// 
	{
		_AddEmployeeInfo(list);
	}

	////////////////////////////////////////////////////////
	// α ..
	if(reqEmpInfoType == reitLogin && GetActorState() == masReceivingBuddyInfo)
	{
		//  !
		if(eErrorCode != wasError_None)
		{
			_LoginFail(pActor, trid, lirtWAS_EmployeeListFail, eErrorCode);
			return true;
		}
		else
		{
			// α Ϸ!!!
			_OnLoginEnd();
		}

		return false;
	}
	else if( reqEmpInfoType == reitAddBuddy || reqEmpInfoType == reitImportBuddy )
	{
		if( list.nSize != 0 )
		{
			std::vector<wstring> vecBuddyID[2];
			vecBuddyID[0].clear();
			vecBuddyID[1].clear();
			for(size_t i = 0; i < list.nSize; i++)
			{
				if (i < 250)
					vecBuddyID[0].push_back(list.pList[i].strUserId);
				else
					vecBuddyID[1].push_back(list.pList[i].strUserId);
			}
				
			m_pNpMsgr->GetNpMsgrBuddy()->Sync_AddBuddy(nGroupID, vecBuddyID[0], L"", trid.GetID());
			if (vecBuddyID[1].size() > 0)
				m_pNpMsgr->GetNpMsgrBuddy()->Sync_AddBuddy(nGroupID, vecBuddyID[1], L"", trid.GetID());

			if( reqEmpInfoType == reitImportBuddy )
			{
				importbuddylist_t::iterator itr = m_vecImportBuddy.begin();
				if( itr != m_vecImportBuddy.end() )
					m_vecImportBuddy.erase(itr);

				itr = m_vecImportBuddy.begin();
				if( itr != m_vecImportBuddy.end() )
				{
					RequestAddBuddyGroup(itr->strGroupName.c_str(), buddyGroupAction_Import);
					OutputDebugString( _T("Next~! ===================================\n") );
				}
				else	// Notify Finished~!
				{
					P_GT_BUDDY_RESULT_DATA sResult;
					sResult.Clear();
					sResult.trid = trid;
					sResult.eAction = buddyAction_Import;
					sResult.eWasError = wasError_None;
					sResult.eError = buddyError_None;

					CBuddyActionNotifyCommand *pCommand = CBuddyActionNotifyCommand::Create(this, sResult);
					if(pCommand)
						pCommand->ExecuteAsync();

					OutputDebugString( _T("FINISH~! ===================================\n") );
				}
			}
		}
		else if (reqEmpInfoType == reitRefreshWorkStatus)
		{
			if( list.nSize != 0 )
			{
				std::vector<wstring> vecBuddyID;
				for(size_t i = 0; i < list.nSize; i++)
				{
				 _RefreshWorkStatus(list.pList[i].strUserId,list.pList[i].strWorkStatus );
					
				}
			}
		}
		else // Notify Failed~!
		{
			P_GT_BUDDY_RESULT_DATA sResult;
			sResult.Clear();
			sResult.trid = trid;
			sResult.eAction = buddyAction_Add;
			sResult.eWasError = wasError_Internal;
			sResult.eError = buddyError_NotFound;

			CBuddyActionNotifyCommand *pCommand = CBuddyActionNotifyCommand::Create(this, sResult);
			if(pCommand)
				pCommand->ExecuteAsync();
		}
	}

	else if (reqEmpInfoType == reitRefreshWorkStatus)
	{
		if( list.nSize != 0 )
		{
			m_vecBuddyWorkStatusData.clear();
			for(size_t i = 0; i < list.nSize; i++)
			{

				NE_MEMBER_DATA* pMemberData = NULL;
				employeemap_t::iterator employeeIterator = m_mapEmployee.find(list.pList[i].strUserId.c_str());
				if (employeeIterator != m_mapEmployee.end())
				{
					pMemberData = &employeeIterator->second;
					if (pMemberData->strWorkStatus != list.pList[i].strWorkStatus)
					{
						pMemberData->strWorkStatus = list.pList[i].strWorkStatus;
						GT_BUDDY_WORK_STATUS_DATA data;
						data.strid = pMemberData->strUserId;
						data.strWorkstatus = pMemberData->strWorkStatus;
						m_vecBuddyWorkStatusData.push_back(data);
					}
				}
			}
			if(m_vecBuddyWorkStatusData.size() > 0)
			{
				CBuddyRefreshWorkStatusNotifyCommand *pCommand = CBuddyRefreshWorkStatusNotifyCommand::Create(this, trid, m_vecBuddyWorkStatusData);
				if(pCommand)
					pCommand->ExecuteAsync();

				OutputDebugString( _T("FINISH~! ===================================\n") );
			}
		}
	}

	return false;
}

bool CMessengerActor::OnGTWASActor_ResponseCheckClientNetwork(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode)
{
	if (m_pNpMsgr != NULL)
		m_pNpMsgr->RecoveryNetwork();
	return false;
}

const NE_MEMBER_DATA* CMessengerActor::GetEmployeeInfo( LPCWSTR pszBuddyID )
{
	const NE_MEMBER_DATA* pMemberData = NULL;

	employeemap_t::const_iterator employeeIterator = m_mapEmployee.find(pszBuddyID);
	if (employeeIterator != m_mapEmployee.end())
	{
		pMemberData = &employeeIterator->second;
	}

	return pMemberData;
}

void CMessengerActor::_LoginFail(IGTWASActor * pActor, trid_t trid, GTLoginErrorCode result, GTWASCallErrorCode eErrorCode)
{
	//NTALK_LOG->Debug(L"[LOGIN] LOGIN_FAIL: [%d][%d][%d]", trid, result, eErrorCode);

	WSTRING strErrorMsg = pActor->GetLastErrorString(trid);

	CHangameLoginResultParser parse;
	parse.SetLoginResult(result, eErrorCode, strErrorMsg.c_str());
	parse.DoParse();
	parse.GetResult(m_sLoginErrorData);

	RequestLogout(lortByWasLoginFail);
	SetActorState(masLoginFailed);
}



///////////////////////////////////////////////////////////////////////////////
// IPT
///////////////////////////////////////////////////////////////////////////////

// ȭ ɱ
bool CMessengerActor::RequestPhoneCall(LPCWSTR strUserID, LPCWSTR strPhoneNo, trid_t *pTrid)
{
	//CGTLifeLog log(__FUNCTION__);

	GT_ASSERT(m_pNpMsgr);

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	bool bRet = m_pNpMsgr->GetNpMsgrIPT()->PhoneCall(strUserID, strPhoneNo, trid.GetID());
	if(bRet)
		_AddMyTransaction(trid);

	return bRet;
}

// ȭ ޱ
bool CMessengerActor::RequestAnswerCall(LPCWSTR strUserID, LPCWSTR strCID, trid_t *pTrid)
{
	//CGTLifeLog log(__FUNCTION__);

	GT_ASSERT(m_pNpMsgr);

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	bool bRet = m_pNpMsgr->GetNpMsgrIPT()->AnswerCall(strUserID, strCID, trid.GetID());
	if(bRet)
		_AddMyTransaction(trid);

	return bRet;
}

// ȭ 
bool CMessengerActor::RequestHangUp(LPCWSTR strUserID, LPCWSTR strCID, trid_t *pTrid)
{
	//CGTLifeLog log(__FUNCTION__);

	GT_ASSERT(m_pNpMsgr);

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	bool bRet = m_pNpMsgr->GetNpMsgrIPT()->HangUp(strUserID, strCID, trid.GetID());
	if(bRet)
		_AddMyTransaction(trid);

	return bRet;
}

//  ȯ
bool CMessengerActor::RequestCallForwarding(LPCWSTR strUserID, BYTE nMode, LPCWSTR strPhoneNo, trid_t *pTrid)
{
	//CGTLifeLog log(__FUNCTION__);

	GT_ASSERT(m_pNpMsgr);

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	bool bRet = m_pNpMsgr->GetNpMsgrIPT()->CallForwarding(strUserID, nMode, strPhoneNo, trid.GetID());
	if(bRet)
		_AddMyTransaction(trid);

	return bRet;
}

//  ȯ 
bool CMessengerActor::RequestCallForwardingInfo(LPCWSTR strUserID, trid_t *pTrid)
{
	//CGTLifeLog log(__FUNCTION__);

	GT_ASSERT(m_pNpMsgr);

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	bool bRet = m_pNpMsgr->GetNpMsgrIPT()->CallForwardingInfo(strUserID, trid.GetID());
	if(bRet)
		_AddMyTransaction(trid);

	return bRet;
}

// ȣ ȯ
bool CMessengerActor::RequestCallTransfer(LPCWSTR strUserID, LPCWSTR strTargetID, trid_t *pTrid)
{
	//CGTLifeLog log(__FUNCTION__);

	GT_ASSERT(m_pNpMsgr);

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	bool bRet = m_pNpMsgr->GetNpMsgrIPT()->CallTransfer(strUserID, strTargetID, trid.GetID());
	if(bRet)
		_AddMyTransaction(trid);

	return bRet;
}

//  ޱ
bool CMessengerActor::RequestCallPickUp(LPCWSTR strUserID, LPCWSTR strTargetID, trid_t *pTrid)
{
	//CGTLifeLog log(__FUNCTION__);

	GT_ASSERT(m_pNpMsgr);

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	bool bRet = m_pNpMsgr->GetNpMsgrIPT()->CallPickUp(strUserID, strTargetID, trid.GetID());
	if(bRet)
		_AddMyTransaction(trid);

	return bRet;
}

// ޽ 
bool CMessengerActor::RequestSetDND(LPCWSTR strUserID, BYTE nMode, trid_t *pTrid)
{
	//CGTLifeLog log(__FUNCTION__);

	GT_ASSERT(m_pNpMsgr);

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	bool bRet = m_pNpMsgr->GetNpMsgrIPT()->SetDND(strUserID, nMode, trid.GetID());
	if(bRet)
		_AddMyTransaction(trid);

	return bRet;
}

// ȭ  û
bool CMessengerActor::RequestPhoneStatus(LPCWSTR strUserID, std::vector<LPCWSTR> &vecUserID, trid_t *pTrid)
{
	//CGTLifeLog log(__FUNCTION__);

	GT_ASSERT(m_pNpMsgr);

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	bool bRet = m_pNpMsgr->GetNpMsgrIPT()->PhoneStatus(strUserID, vecUserID, trid.GetID());
	if(bRet)
		_AddMyTransaction(trid);

	return bRet;
}

// ȸ ȭ
bool CMessengerActor::RequestConferenceCall(LPCWSTR strUserID, LPCWSTR strPhoneNo, trid_t *pTrid)
{
	//CGTLifeLog log(__FUNCTION__);

	GT_ASSERT(m_pNpMsgr);

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	bool bRet = m_pNpMsgr->GetNpMsgrIPT()->ConferenceCall(strUserID, strPhoneNo, trid.GetID());
	if(bRet)
		_AddMyTransaction(trid);

	return bRet;
}

//  
bool CMessengerActor::RequestHoldCall(LPCWSTR strUserID, LPCWSTR strCID, trid_t *pTrid)
{
	//CGTLifeLog log(__FUNCTION__);

	GT_ASSERT(m_pNpMsgr);

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	bool bRet = m_pNpMsgr->GetNpMsgrIPT()->HoldCall(strUserID, strCID, trid.GetID());
	if(bRet)
		_AddMyTransaction(trid);

	return bRet;
}

//   
bool CMessengerActor::RequestResumeCall(LPCWSTR strUserID, LPCWSTR strCID, trid_t *pTrid)
{
	//CGTLifeLog log(__FUNCTION__);

	GT_ASSERT(m_pNpMsgr);

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	bool bRet = m_pNpMsgr->GetNpMsgrIPT()->ResumeCall(strUserID, strCID, trid.GetID());
	if(bRet)
		_AddMyTransaction(trid);

	return bRet;
}

// ޽  
bool CMessengerActor::RequestDndStatusInfo(LPCWSTR strUserID, trid_t *pTrid)
{
	//CGTLifeLog log(__FUNCTION__);

	GT_ASSERT(m_pNpMsgr);

	// α  쿡 ó!
	if(!IsValidLoginState())
		return false;

	trid_t trid = GT_GLOBAL->GetTransactionID(pTrid);

	bool bRet = m_pNpMsgr->GetNpMsgrIPT()->DndStatusInfo(strUserID, trid.GetID());
	if(bRet)
		_AddMyTransaction(trid);

	return bRet;
}

bool CMessengerActor::_RefreshWorkStatus( std::wstring &strUserID, std::wstring &strWorkStaus )
{
	bool bRet = false;
	NE_MEMBER_DATA* pMemberData = NULL;
	employeemap_t::iterator employeeIterator = m_mapEmployee.find(strUserID.c_str());
	if (employeeIterator != m_mapEmployee.end())
	{
		pMemberData = &employeeIterator->second;
		pMemberData->strWorkStatus = strWorkStaus;
		bRet = true;
	}

	return bRet;
}

IGTBuddyGroup* CMessengerActor::GetVirtualBuddyGroup(GT_BUDDY_GROUP_DATA data)
{
	m_VirtualBuddyGroup.SetData(data);
	return static_cast<IGTBuddyGroup*>(&m_VirtualBuddyGroup);
}

IGTBuddyUser* CMessengerActor::GetVirtualBuddyUser()
{
	return static_cast<IGTBuddyUser*>(&m_VirtualBuddyUser);
}

